Type: Package
Package: emayili
Title: Send Email Messages
Version: 0.9.3
Authors@R: 
    c(person(given = c("Andrew", "B."),
             family = "Collier",
             role = c("aut", "cre", "cph"),
             email = "andrew.b.collier@gmail.com"),
      person(given = "Matt",
             family = "Dennis",
             role = "ctb",
             email = "matt@fathomdata.dev"),
      person(given = "Antoine",
             family = "Bichat",
             role = "ctb",
             email = "a.bichat@yahoo.fr",
             comment = c(ORCID = "0000-0001-6599-7081")),
      person(given = "Daniel",
             family = "Fahey",
             role = "ctb",
             email = "dpfahey@gmail.com"),
      person(given = c("Johann",  "R."),
             family = "Kleinbub",
             role = "ctb",
             email = "johann.kleinbub@gmail.com"),
      person(given = c("Panagiotis"),
             family = "Moulos",
             role = "ctb",
             email = "pmoulos@gmail.com"),
      person(given = "Swechhya",
             family = "Bista",
             role = "ctb",
             email = "swechhyabista@gmail.com"),
      person(given = "Colin",
             family = "Fay",
             role = "ctb",
             email = "contact@colinfay.me",
             comment = c(ORCID = "0000-0001-7343-1846")))
Description: A light, simple tool for sending emails with minimal dependencies.
URL: https://datawookie.github.io/emayili/
BugReports: https://github.com/datawookie/emayili/issues
License: GPL-3
Language: en-GB
Imports: base64enc, commonmark, curl (>= 4.0), digest, dplyr, glue,
        htmltools, httr, logger, magrittr (>= 2.0.1), mime, purrr,
        rmarkdown, rvest, stringi, stringr, tidyr, urltools, xfun, xml2
Suggests: cld2, cld3, gpg, here, jinjar, lintr, memoise, testthat (>=
        2.1.0), roxygen2, showtext, Microsoft365R
SystemRequirements: The function render() requires Pandoc
        (http://pandoc.org). To use PGP/GnuPG encryption requires gpg.
Encoding: UTF-8
RoxygenNote: 7.3.2
KeepSource: true
NeedsCompilation: no
Packaged: 2025-02-07 05:18:37 UTC; wookie
Author: Andrew B. Collier [aut, cre, cph],
  Matt Dennis [ctb],
  Antoine Bichat [ctb] (<https://orcid.org/0000-0001-6599-7081>),
  Daniel Fahey [ctb],
  Johann R. Kleinbub [ctb],
  Panagiotis Moulos [ctb],
  Swechhya Bista [ctb],
  Colin Fay [ctb] (<https://orcid.org/0000-0001-7343-1846>)
Maintainer: Andrew B. Collier <andrew.b.collier@gmail.com>
Repository: CRAN
Date/Publication: 2025-02-07 05:40:02 UTC
Built: R 4.6.0; ; 2026-04-29 16:29:01 UTC; unix

Type: Package
Package: emayili
Title: Send Email Messages
Version: 0.7.0
Authors@R: 
    c(person(given = c("Andrew", "B."),
             family = "Collier",
             role = c("aut", "cre", "cph"),
             email = "andrew@fathomdata.dev"),
      person(given = "Matt",
             family = "Dennis",
             role = "ctb",
             email = "matt@fathomdata.dev"),
      person(given = "Antoine",
             family = "Bichat",
             role = "ctb",
             email = "a.bichat@yahoo.fr",
             comment = c(ORCID = "0000-0001-6599-7081")),
      person(given = "Daniel",
             family = "Fahey",
             role = "ctb",
             email = "dpfahey@gmail.com"),
      person(given = c("Johann",  "R."),
             family = "Kleinbub",
             role = "ctb",
             email = "johann.kleinbub@gmail.com"),
      person(given = c("Panagiotis"),
             family = "Moulos",
             role = "ctb",
             email = "pmoulos@gmail.com"),
      person(given = "Swechhya",
             family = "Bista",
             role = "ctb",
             email = "swechhyabista@gmail.com"),
      person(given = "Colin",
             family = "Fay",
             role = "ctb",
             email = "contact@colinfay.me",
             comment = c(ORCID = "0000-0001-7343-1846")))
Description: A light, simple tool for sending emails with minimal dependencies.
URL: https://datawookie.github.io/emayili/
BugReports: https://github.com/datawookie/emayili/issues
License: GPL-3
Language: en-GB
Imports: base64enc, commonmark, curl (>= 4.0), digest, dplyr, glue,
        htmltools, httr, logger, magrittr, mime, purrr, rmarkdown,
        stringi, stringr, tidyr, urltools, vctrs, xfun, xml2
Suggests: cld2, cld3, gpg, here, memoise, testthat (>= 2.1.0),
        roxygen2, showtext, Microsoft365R
SystemRequirements: The function render() requires Pandoc
        (http://pandoc.org). To use PGP/GnuPG encryption requires gpg.
Encoding: UTF-8
RoxygenNote: 7.1.2
KeepSource: true
NeedsCompilation: no
Packaged: 2021-12-12 15:39:07 UTC; wookie
Author: Andrew B. Collier [aut, cre, cph],
  Matt Dennis [ctb],
  Antoine Bichat [ctb] (<https://orcid.org/0000-0001-6599-7081>),
  Daniel Fahey [ctb],
  Johann R. Kleinbub [ctb],
  Panagiotis Moulos [ctb],
  Swechhya Bista [ctb],
  Colin Fay [ctb] (<https://orcid.org/0000-0001-7343-1846>)
Maintainer: Andrew B. Collier <andrew@fathomdata.dev>
Repository: CRAN
Date/Publication: 2021-12-13 09:30:09 UTC

<!-- README.md is generated from README.Rmd. Please edit that file -->

# emayili <img src="man/figures/emayili-hex.png" align="right" alt="" width="120" />

<!-- badges: start -->

[![CRAN
status](https://www.r-pkg.org/badges/version/emayili)](https://cran.r-project.org/package=emayili)
![GitHub Actions build
status](https://github.com/datawookie/emayili/actions/workflows/build.yaml/badge.svg)
[![Codecov test
coverage](https://img.shields.io/codecov/c/github/datawookie/emayili.svg)](https://app.codecov.io/gh/datawookie/emayili)
[![Lifecycle:
stable](https://img.shields.io/badge/lifecycle-stable-green.svg)](https://lifecycle.r-lib.org/articles/stages.html)
<!-- badges: end -->

`{emayili}` is a package for sending emails from R. The design goals
are:

- works on all manner of SMTP servers and
- has minimal dependencies (or dependencies which are easily satisfied).

The package name is an adaption of the Zulu word for email, *imeyili*.

The documentation for `{emayili}` can be found
[here](https://datawookie.github.io/emayili/).

Not that I pretend to have many stars on this project, but these plots
are quite fun.

[![Star History
Chart](https://api.star-history.com/svg?repos=datawookie/emayili&type=Date)](https://star-history.com/#datawookie/emayili&Date)

## Installation

Get the stable version from
[CRAN](https://CRAN.R-project.org/package=emayili).

``` r
install.packages("emayili")
```

Or grab it directly from
[GitHub](https://github.com/datawookie/emayili).

``` r
# Install from the master branch.
remotes::install_github("datawookie/emayili")
# Install from the development branch.
remotes::install_github("datawookie/emayili", ref = "dev")
```

## Usage

Load the library.

``` r
library(emayili)

packageVersion("emayili")
```

    [1] '0.9.3'

Create a message object.

``` r
email <- envelope()
```

### Creating a Message

The message has class `envelope`.

``` r
class(email)
```

    [1] "envelope"

Add addresses for the sender and recipient.

``` r
email <- email %>%
  from("alice@yahoo.com") %>%
  to("bob@google.com") %>%
  cc("craig@google.com")
```

There are also `bcc()` and `reply()` functions for setting the `Bcc` and
`Reply-To` fields.

You can supply multiple addresses in a variety of formats:

- as a single comma-separated string
- as separate strings; or
- as a vector of strings.

``` r
envelope() %>% to("bob@google.com, craig@google.com, erin@gmail.com")
envelope() %>% to("bob@google.com", "craig@google.com", "erin@gmail.com")
envelope() %>% to(c("bob@google.com", "craig@google.com", "erin@gmail.com"))
```

Add a subject.

``` r
email <- email %>% subject("This is a plain text message!")
```

Add a text body.

``` r
email <- email %>% text("Hello!")
```

You can use `html()` to add an HTML body. It accepts either a vector of
characters or a `tagList()` from `{htmltools}`.

``` r
library(htmltools)

email <- email %>% html(
  tagList(
    h2("Hello"),
    p("World!")
  )
)
```

Add an attachment.

``` r
email <- email %>% attachment("image.jpg")
```

You can also create the message in a single command:

``` r
email <- envelope(
  to = "bob@google.com",
  from = "alice@yahoo.com",
  subject = "This is a plain text message!",
  text = "Hello!"
)
```

Simply printing a message displays the header information.

``` r
email
```

    Date:                         Fri, 07 Feb 2025 04:50:01 GMT
    X-Mailer:                     {emayili}-0.9.3
    MIME-Version:                 1.0
    From:                         alice@yahoo.com
    To:                           bob@google.com
    Cc:                           craig@google.com
    Subject:                      This is a plain text message!

You can identify emails which have been sent using `{emayili}` by the
presence of an `X-Mailer` header which includes both the package name
and version.

If you want to see the complete MIME object, just convert to a string.

You can also call the `print()` method and specify `details = TRUE`.

### Options

You can set the `envelope.details` option to assert that the details
should always be printed.

``` r
# Always print envelope details.
#
options(envelope.details = TRUE)
```

By default the results returned by most of the methods are invisible.
You can make them visible via the `envelope.invisible` (default:
`TRUE`).

``` r
# Always show envelope.
#
options(envelope.invisible = FALSE)
```

### Interpolating Text

You can use `{glue}` syntax to interpolate content into the body of a
message.

``` r
name <- "Alice"

envelope() %>%
  text("Hello {{name}}!")
```

    Date:                         Fri, 07 Feb 2025 04:50:01 GMT
    X-Mailer:                     {emayili}-0.9.3
    MIME-Version:                 1.0
    Content-Type:                 text/plain; 
                                  charset=utf-8; 
                                  format=flowed
    Content-Transfer-Encoding:    7bit
    Content-MD5:                  nhjeY5ZYMzru+kSCGUzNKg==

    Hello Alice!

### Rendering Markdown

You can render Markdown straight into a message.

Use either plain Markdown.

``` r
envelope() %>%
  # Render plain Markdown from a character vector.
  render(
    "Check out [`{emayili}`](https://cran.r-project.org/package=emayili)."
  )
```

    Date:                         Fri, 07 Feb 2025 04:50:01 GMT
    X-Mailer:                     {emayili}-0.9.3
    MIME-Version:                 1.0
    Content-Type:                 text/html; 
                                  charset=utf-8

    <html><body><p>Check out <a href="https://cran.r-project.org/package=emayili"><code>{emayili}</code></a>.</p></body></html>

Or R Markdown.

``` r
envelope() %>%
  # Render R Markdown from a file.
  render("message.Rmd")
```

In both cases the function will accept either a file path or a character
vector containing Markdown text.

<img src="man/figures/screenshot-email-rendered.png" style="filter: drop-shadow(5px 5px 5px black); margin-bottom: 5px;">

Interpolation also works with `render()`.

### Rendered CSS

When you render an R Markdown document the resulting HTML includes CSS
from three sources:

- [Bootstrap](https://getbootstrap.com/)
- [highlightjs](https://highlightjs.org/) and
- `{rmarkdown}`.

You can control which of these propagate to the message using the
`include_css` parameter which, by default, is set to
`c("rmd", "bootstrap", "highlight")`.

🚨 *Note:* Gmail doesn’t like the Bootstrap CSS. If you want your
styling to work on Gmail you should set
`include_css =  c("rmd", "highlight")`.

### Extra CSS

You can insert extra CSS into your rendered messages.

``` r
envelope() %>%
  render("message.Rmd", css_files = "extra.css")
```

If you are having trouble getting this to work with Gmail then it might
be worthwhile taking a look at their [CSS
support](https://developers.google.com/gmail/design/css).

### Adding an Inline Image

Adding an inline image to an HTML message is possible. There are two
ways to achieve this.

*1. Base64 Encoding*

First you’ll need to [Base64
encode](https://en.wikipedia.org/wiki/Base64) the image.

``` r
img_base64 <- base64enc::base64encode("image.jpg")
```

Then create the HTML message body.

``` r
html_body <- sprintf('<html><body><img src="data:image/jpeg;base64,%s"></body></html>', img_base64)
```

And finally add it to the email.

``` r
email <- envelope() %>% html(html_body)
```

*Note:* It’s important that you specify the appropriate media type
(`image/jpeg` for JPEG and `image/png` for PNG).

*2. Using a CID*

Unfortunately some mail clients (like Gmail) will not display Base64
encoded images. In this case using a CID is a working alternative.

First create the message body which references an image by CID.

``` r
html_body <- '<html><body><img src="cid:image"></body></html>'
```

Then attach the image and specify the `cid` argument.

``` r
email <- envelope() %>%
  html(html_body) %>%
  attachment(path = "image.jpg", cid = "image")
```

### Create a Server Object

Create a SMTP server object.

``` r
smtp <- server(
  host = "smtp.gmail.com",
  port = 465,
  username = "bob@gmail.com",
  password = "bd40ef6d4a9413de9c1318a65cbae5d7"
)
```

It’s bad practice to include credentials in a script. A better approach
would be to keep the credentials in your `.Renviron` file.

    GMAIL_USERNAME="bob@gmail.com"
    GMAIL_PASSWORD="bd40ef6d4a9413de9c1318a65cbae5d7"

You can then pull these variables into R using `Sys.getenv()` and then
create the server object.

``` r
smtp <- server(
  host = "smtp.gmail.com",
  port = 465,
  username = Sys.getenv("GMAIL_USERNAME"),
  password = Sys.getenv("GMAIL_PASSWORD")
)
```

If you’re trying to send email with a host that uses the STARTTLS
security protocol (like Gmail, Yahoo! or AOL), then it will most
probably be blocked due to insufficient security. In order to circumvent
this, you can grant access to less secure apps. See the links below for
specifics:

- [Gmail](https://myaccount.google.com/security)
- [Yahoo!](https://login.yahoo.com/account/security) and
- [AOL](https://login.aol.com/account/security).

Gmail has recently changed their authentication procedure. If you are
having trouble connecting to the Gmail SMTP server then take a look at
[this](https://datawookie.dev/blog/2022/03/updated-gmail-authentication/).

### Sending a Message

Send the message.

``` r
smtp(email, verbose = TRUE)
```

To see the guts of the message as passed to the SMTP server:

``` r
print(email, details = TRUE)
```

### Encryption

Both transport-level encryption and end-to-end [email
encryption](https://en.wikipedia.org/wiki/Email_encryption) are
supported. An SMTP connection can be initiated on port 465 (SMTPS, see
[RFC 8314](https://www.rfc-editor.org/rfc/rfc8314)) or 587 (SMTP-MSA,
see [RFC 6409](https://www.rfc-editor.org/rfc/rfc6409)), enabling
transport-level encryption. Public-key cryptography (via GnuPG) can be
used to sign and/or encrypt message contents for end-to-end encryption.

## Standards Documents

The following (draft) standards documents relate to emails:

- [RFC 2822](https://www.rfc-editor.org/rfc/rfc2822) — Internet Message
  Format
- [RFC 5321](https://www.rfc-editor.org/rfc/rfc5321) — Simple Mail
  Transfer Protocol
- [RFC 5322](https://www.rfc-editor.org/rfc/rfc5322) — Internet Message
  Format
- [RFC 6854](https://www.rfc-editor.org/rfc/rfc6854) — an update to RFC
  5322.

## Similar Packages

There is a selection of other R packages which also send emails:

- [blastula](https://cran.r-project.org/package=blastula)
- [blatr](https://cran.r-project.org/package=blatr) (Windows)
- [gmailr](https://cran.r-project.org/package=gmailr)
- [mail](https://cran.r-project.org/package=mail)
- [mailR](https://cran.r-project.org/package=mailR)
- [sendmailR](https://cran.r-project.org/package=sendmailR)
- [ponyexpress](https://github.com/ropensci-archive/ponyexpress)

## Blog Posts

<table>
<tr>
<td>
<img src="https://datawookie.dev/blog/2021/10/emayili-support-for-gmail-sendgrid-mailgun/featured.jpg" width="100px">
</td>
<td>
<a href="https://datawookie.dev/blog/2021/10/emayili-support-for-gmail-sendgrid-mailgun/">Support
for Gmail, SendGrid & Mailgun</a>
</td>
</tr>
<tr>
<td>
<img src="https://datawookie.dev/blog/2021/10/emayili-message-precedence/featured.jpg" width="100px">
</td>
<td>
<a href="https://datawookie.dev/blog/2021/10/emayili-message-precedence/">Message
Precedence</a>
</td>
</tr>
<tr>
<td>
<img src="https://datawookie.dev/blog/2021/10/emayili-message-integrity/featured.jpg" width="100px">
</td>
<td>
<a href="https://datawookie.dev/blog/2021/10/emayili-message-integrity/">Message
Integrity</a>
</td>
</tr>
<tr>
<td>
<img src="https://datawookie.dev/blog/2021/09/emayili-right-to-left/featured.jpg" width="100px">
</td>
<td>
<a href="https://datawookie.dev/blog/2021/09/emayili-right-to-left/">Right-to-Left</a>
</td>
</tr>
<tr>
<td>
<img src="https://datawookie.dev/blog/2021/09/emayili-styling-figures/featured.jpg" width="100px">
</td>
<td>
<a href="https://datawookie.dev/blog/2021/09/emayili-styling-figures/">Styling
Figures</a>
</td>
</tr>
<tr>
<td>
<img src="https://datawookie.dev/blog/2021/09/emayili-managing-css/featured.jpg" width="100px">
</td>
<td>
<a href="https://datawookie.dev/blog/2021/09/emayili-managing-css/">Managing
CSS</a>
</td>
</tr>
<tr>
<td>
<img src="https://datawookie.dev/blog/2021/09/emayili-r-markdown-parameters/featured.jpg" width="100px">
</td>
<td>
<a href="https://datawookie.dev/blog/2021/09/emayili-r-markdown-parameters/">R
Markdown Parameters</a>
</td>
</tr>
<tr>
<td>
<img src="https://datawookie.dev/blog/2021/09/emayili-rendering-r-markdown/featured.jpg" width="100px">
</td>
<td>
<a href="https://datawookie.dev/blog/2021/09/emayili-rendering-r-markdown/">Rendering
R Markdown</a>
</td>
</tr>
<tr>
<td>
<img src="https://datawookie.dev/blog/2021/09/emayili-rendering-plain-markdown/featured.jpg" width="100px">
</td>
<td>
<a href="https://datawookie.dev/blog/2021/09/emayili-rendering-plain-markdown">Rendering
Plain Markdown</a>
</td>
</tr>
<tr>
<td>
<img src="https://datawookie.dev/blog/2021/09/emayili-interpolating-message-content/featured.jpg" width="100px">
</td>
<td>
<a href="https://datawookie.dev/blog/2021/09/emayili-interpolating-message-content">Interpolating
Message Content</a>
</td>
</tr>
<tr>
<td>
<img src="https://datawookie.dev/blog/2021/08/emayili-rudimentary-email-address-validation/featured.jpg" width="100px">
</td>
<td>
<a href="https://datawookie.dev/blog/2021/08/emayili-rudimentary-email-address-validation">Rudimentary
Email Address Validation</a>
</td>
</tr>
<tr>
<td>
<img src="https://datawookie.dev/blog/2022/03/updated-gmail-authentication/featured.jpg" width="100px">
</td>
<td>
<a href="https://datawookie.dev/blog/2022/03/updated-gmail-authentication/">Updated
Gmail Authentication</a>
</td>
</tr>
</table>

## Developer Notes

### Code Coverage

You can find the test coverage report at
[Codecov](https://app.codecov.io/gh/datawookie/emayili). For development
purposes it’s more convenient to use the
[`{covr}`](https://cran.r-project.org/package=covr) package.

Generate a coverage report.

``` r
library(covr)

# Tests that are skipped on CRAN should still be included in coverage report.
#
Sys.setenv(NOT_CRAN = "true")

report()
```

Calculate test coverage.

``` r
coverage <- package_coverage()
```

Coverage statistics as a data frame.

``` r
as.data.frame(coverage)
```

Show lines without coverage.

``` r
zero_coverage(coverage)
```

### Checks

Check spelling.

``` r
spelling::spell_check_package()
```

Quick local checks.

``` r
devtools::check()
```

Remote checks (take longer but more thorough).

``` r
devtools::check_win_devel()

# Check for a specific platform.
#
rhub::check(platform = "debian-gcc-devel")
rhub::check_on_windows(check_args = "--force-multiarch")
rhub::check_on_solaris()

# Check on a bunch of platforms.
#
rhub::check_for_cran()

# Check on important platforms.
#
rhub::check_for_cran(platforms = c(
  "debian-gcc-release",
  "ubuntu-gcc-release",
  "macos-m1-bigsur-release",
  "windows-x86_64-release",
  NULL
))
```

<!-- README.md is generated from README.Rmd. Please edit that file -->

# emayili <img src="man/figures/emayili-hex.png" align="right" alt="" width="120" />

<!-- badges: start -->

[![CRAN
status](https://www.r-pkg.org/badges/version/emayili)](https://cran.r-project.org/package=emayili)
![GitHub Actions build
status](https://github.com/datawookie/emayili/actions/workflows/build.yaml/badge.svg)
[![Codecov test
coverage](https://img.shields.io/codecov/c/github/datawookie/emayili.svg)](https://codecov.io/github/datawookie/emayili)
[![Lifecycle:
experimental](https://img.shields.io/badge/lifecycle-experimental-orange.svg)](https://lifecycle.r-lib.org/articles/stages.html)
<!-- badges: end -->

`{emayili}` is a package for sending emails from R. The design goals
are:

-   works on all manner of SMTP servers and
-   has minimal dependencies (or dependencies which are easily
    satisfied).

The package name is an adaption of the Zulu word for email, *imeyili*.

The documentation for `{emayili}` can be found
[here](https://datawookie.github.io/emayili/).

## Installation

Get the stable version from
[CRAN](https://CRAN.R-project.org/package=emayili).

``` r
install.packages("emayili")
```

Or grab it directly from
[GitHub](https://github.com/datawookie/emayili).

``` r
# Install from the master branch.
remotes::install_github("datawookie/emayili")
# Install from the development branch.
remotes::install_github("datawookie/emayili", ref = "dev")
```

## Usage

Load the library.

``` r
library(emayili)

packageVersion("emayili")
```

    [1] '0.7.0'

Create a message object.

``` r
email <- envelope()
```

### Creating a Message

The message has class `envelope`.

``` r
class(email)
```

    [1] "envelope"

Add addresses for the sender and recipient.

``` r
email <- email %>%
  from("alice@yahoo.com") %>%
  to("bob@google.com") %>%
  cc("craig@google.com")
```

There are also `bcc()` and `reply()` functions for setting the `Bcc` and
`Reply-To` fields.

You can supply multiple addresses in a variety of formats:

-   as a single comma-separated string
-   as separate strings; or
-   as a vector of strings.

``` r
envelope() %>% to("bob@google.com, craig@google.com, erin@gmail.com")
envelope() %>% to("bob@google.com", "craig@google.com", "erin@gmail.com")
envelope() %>% to(c("bob@google.com", "craig@google.com", "erin@gmail.com"))
```

Add a subject.

``` r
email <- email %>% subject("This is a plain text message!")
```

Add a text body.

``` r
email <- email %>% text("Hello!")
```

You can use `html()` to add an HTML body. It accepts either a vector of
characters or a `tagList()` from `{htmltools}`.

``` r
library(htmltools)

email <- email %>% html(
  tagList(
    h2("Hello"),
    p("World!")
  )
)
```

Add an attachment.

``` r
email <- email %>% attachment("image.jpg")
```

You can also create the message in a single command:

``` r
email <- envelope(
  to = "bob@google.com",
  from = "alice@yahoo.com",
  subject = "This is a plain text message!",
  text = "Hello!"
)
```

Simply printing a message displays the header information.

``` r
email
```

    Date:                        Sun, 12 Dec 2021 15:09:23 GMT
    X-Mailer:                    {emayili}-0.7.0
    MIME-Version:                1.0
    From:                        alice@yahoo.com
    To:                          bob@google.com
    Cc:                          craig@google.com
    Subject:                     This is a plain text message!

You can identify emails which have been sent using `{emayili}` by the
presence of an `X-Mailer` header which includes both the package name
and version.

If you want to see the complete MIME object, just convert to a string.

You can also call the `print()` method and specify `details = TRUE`.

### Options

You can set the `envelope.details` option to assert that the details
should always be printed.

``` r
# Always print envelope details.
#
options(envelope.details = TRUE)
```

By default the results returned by most of the methods are invisible.
You can make them visible via the `envelope.invisible` (default:
`TRUE`).

``` r
# Always show envelope.
#
options(envelope.invisible = FALSE)
```

### Interpolating Text

You can use `{glue}` syntax to interpolate content into the body of a
message.

``` r
name <- "Alice"

envelope() %>%
  text("Hello {{name}}!")
```

    Date:                        Sun, 12 Dec 2021 15:09:23 GMT
    X-Mailer:                    {emayili}-0.7.0
    MIME-Version:                1.0
    Content-Type:                text/plain;
                                  charset=utf-8;
                                  format=flowed
    Content-Disposition:         inline
    Content-Transfer-Encoding:   7bit
    Content-MD5:                 nhjeY5ZYMzru+kSCGUzNKg==

    Hello Alice!

### Rendering Markdown

You can render Markdown straight into a message.

Use either plain Markdown.

``` r
envelope() %>%
  # Render plain Markdown from a character vector.
  render(
    "Check out [`{emayili}`](https://cran.r-project.org/package=emayili)."
  )
```

    Date:                        Sun, 12 Dec 2021 15:09:23 GMT
    X-Mailer:                    {emayili}-0.7.0
    MIME-Version:                1.0
    Content-Type:                text/html;
                                  charset=utf-8
    Content-Disposition:         inline

    <!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.0 Transitional//EN" "http://www.w3.org/TR/REC-html40/loose.dtd">
    <html><body><p>Check out <a href="https://cran.r-project.org/package=emayili"><code>{emayili}</code></a>.</p></body></html>

Or R Markdown.

``` r
envelope() %>%
  # Render R Markdown from a file.
  render("message.Rmd")
```

In both cases the function will accept either a file path or a character
vector containing Markdown text.

<img src="man/figures/screenshot-email-rendered.png" style="filter: drop-shadow(5px 5px 5px black); margin-bottom: 5px;">

Interpolation also works with `render()`.

### Rendered CSS

When you render an R Markdown document the resulting HTML includes CSS
from three sources:

-   [Bootstrap](https://getbootstrap.com/)
-   [highlightjs](https://highlightjs.org/) and
-   `{rmarkdown}`.

You can control which of these propagate to the message using the
`include_css` parameter which, by default, is set to
`c("rmd", "bootstrap", "highlight")`.

🚨 *Note:* Gmail doesn’t like the Bootstrap CSS. If you want your styling
to work on Gmail you should set `include_css =  c("rmd", "highlight")`.

### Extra CSS

You can insert extra CSS into your rendered messages.

``` r
envelope() %>%
  render("message.Rmd", css_files = "extra.css")
```

If you are having trouble getting this to work with Gmail then it might
be worthwhile taking a look at their [CSS
support](https://developers.google.com/gmail/design/css).

### Adding an Inline Image

Adding an inline image to an HTML message is possible. There are two
ways to achieve this.

*1. Base64 Encoding*

First you’ll need to [Base64
encode](https://en.wikipedia.org/wiki/Base64) the image.

``` r
img_base64 <- base64enc::base64encode("image.jpg")
```

Then create the HTML message body.

``` r
html_body <- sprintf('<html><body><img src="data:image/jpeg;base64,%s"></body></html>', img_base64)
```

And finally add it to the email.

``` r
email <- envelope() %>% html(html_body)
```

*Note:* It’s important that you specify the appropriate media type
(`image/jpeg` for JPEG and `image/png` for PNG).

*2. Using a CID*

Unfortunately some mail clients (like Gmail) will not display Base64
encoded images. In this case using a CID is a working alternative.

First create the message body which references an image by CID.

``` r
html_body <- '<html><body><img src="cid:image"></body></html>'
```

Then attach the image and specify the `cid` argument.

``` r
email <- envelope() %>%
  html(html_body) %>%
  attachment(path = "image.jpg", cid = "image")
```

### Sending a Message

Create a SMTP server object and send the message.

``` r
smtp <- server(
  host = "smtp.gmail.com",
  port = 465,
  username = "bob@gmail.com",
  password = "bd40ef6d4a9413de9c1318a65cbae5d7"
)
smtp(email, verbose = TRUE)
```

To see the guts of the message as passed to the SMTP server:

``` r
print(email, details = TRUE)
```

### Using STARTTLS

If you’re trying to send email with a host that uses the STARTTLS
security protocol (like Google Mail, Yahoo! or AOL), then it will most
probably be blocked due to insufficient security. In order to circumvent
this, you can grant access to less secure apps.

## Standards Documents

The following (draft) standards documents relate to emails:

-   [RFC 2822](https://tools.ietf.org/html/rfc2822)
-   [RFC 5322](https://tools.ietf.org/html/rfc5322)
-   [RFC 6854](https://tools.ietf.org/html/rfc6854) (an update to RFC
    5322).

## Similar Packages

There is a selection of other R packages which also send emails:

-   [blastula](https://cran.r-project.org/package=blastula)
-   [blatr](https://cran.r-project.org/package=blatr) (Windows)
-   [gmailr](https://cran.r-project.org/package=gmailr)
-   [mail](https://cran.r-project.org/package=mail)
-   [mailR](https://cran.r-project.org/package=mailR)
-   [sendmailR](https://cran.r-project.org/package=sendmailR)
-   [ponyexpress](https://github.com/ropensci-archive/ponyexpress)

## Developer Notes

### Code Coverage

You can find the test coverage report at
[Codecov](https://app.codecov.io/gh/datawookie/emayili). For development
purposes it’s more convenient to use the
[`{covr}`](https://cran.r-project.org/package=covr) package.

Generate a coverage report.

``` r
library(covr)

# Tests that are skipped on CRAN should still be included in coverage report.
#
Sys.setenv(NOT_CRAN = "true")

report()
```

Calculate test coverage.

``` r
coverage <- package_coverage()
```

Coverage statistics as a data frame.

``` r
as.data.frame(coverage)
```

Show lines without coverage.

``` r
zero_coverage(coverage)
```

### Checks

Check spelling.

``` r
spelling::spell_check_package()
```

Use [rhub](https://r-hub.github.io/rhub/) to test on various platforms.

``` r
# Check for a specific platform.
#
rhub::check(platform = "debian-gcc-devel")
rhub::check_on_windows(check_args = "--force-multiarch")
rhub::check_on_solaris()

# Check on a bunch of platforms.
#
rhub::check_for_cran()

# Check on important platforms.
#
rhub::check_for_cran(platforms = c(
  "debian-gcc-release",
  "ubuntu-gcc-release",
  "macos-m1-bigsur-release",
  "windows-x86_64-release",
  NULL
))
```

library(hexSticker)
library(showtext)

# Load Google font.
#
font_add_google("Roboto Slab", "roboto_slab")
showtext_auto()

sticker(here::here("inst/hex/envelope-regular.png"),
  # Image
  s_x = 1,
  s_y = 1.10,
  s_width = 0.6,
  s_height = 0.6,
  # Package name
  package = "{emayili}",
  p_size = 16,
  p_y = 0.45,
  p_color = "#ffffff",
  p_family = "roboto_slab",
  # Hex
  h_fill = "#3498db",
  h_color = "#000000",
  # Output
  filename = here::here("man/figures/emayili-hex.png"),
  dpi = 300
)

# https://www.ddrive.no/post/making-hex-and-twittercard-with-bunny-and-magick/

library(magick)
# remotes::install_github("dmi3kno/bunny")
library(bunny)

hex <- image_read(here::here("man/figures/emayili-hex.png")) %>%
  image_scale("400x400")

gh_logo <- bunny::github %>% image_scale("50x50")

gh_card <- image_canvas_ghcard("#ffffff") %>%
  image_compose(hex, gravity = "East", offset = "+80+0") %>%
  image_annotate(
    "emayili: Email from R",
    gravity = "West",
    location = "+80-30",
    color = "#0d4448",
    size = 50,
    font = "Roboto Slab"
  ) %>%
  image_compose(gh_logo, gravity = "West", offset = "+80+45") %>%
  image_annotate(
    "datawookie/emayili",
    gravity = "West",
    location = "+140+45",
    size = 50,
    font = "Ubuntu Mono"
  ) %>%
  image_border_ghcard("#8b9196")

gh_card

gh_card %>%
  image_write(here::here("man/figures/emayili-github-card.png"))

library(shiny)
library(httr)
library(emayili)

# Setup:
#
# 1. Create an .Renviron file in the same directory as the app and provide
#    values for:
#
#    - SMTP_SERVER
#    - SMTP_PORT
#    - SMTP_USERNAME
#    - SMTP_PASSWORD
#
# 2. Deploy using rsconnect::deployApp().

smtp_server <- Sys.getenv("SMTP_SERVER")
smtp_port <- Sys.getenv("SMTP_PORT")
smtp_username <- Sys.getenv("SMTP_USERNAME")

IP <- content(GET("https://api.ipify.org?format=json"))$ip

smtp <- server(
  host = smtp_server,
  port = smtp_port,
  username = smtp_username,
  password = Sys.getenv("SMTP_PASSWORD"),
  max_times = 1
)

ui <- fluidPage(
  titlePanel("{emayili} & Shiny"),
  tags$head(
    tags$style(HTML("
      body {
        background-color: black;
        color: white;
      }
      td {
        padding-left: 10px;
      }
    "))
  ),
  fluidRow(
    column(
      width = 6,
      tags$table(
        tags$tr(
          tags$th("{emayili version}:"),
          tags$td(as.character(packageVersion("emayili")))
        ),
        tags$tr(
          tags$th("IP address:"),
          tags$td(IP)
        ),
        tags$tr(
          tags$th("SMTP server:"),
          tags$td(smtp_server)
        ),
        tags$tr(
          tags$th("SMTP port:"),
          tags$td(smtp_port)
        )
      )
    ),
    column(
      width = 6,
      class = "text-center",
      actionButton(
        "send",
        "Send Message",
        icon = icon("envelope"),
        class = "btn-primary"
      )
    )
  )
)

server <- function(input, output, session) {
  observeEvent(input$send, {
    message("Sending message to ", smtp_username, ".")
    envelope(
      to = smtp_username,
      from = smtp_username,
      subject = strftime(Sys.time(), "{emayili} & Shiny [%F %X]")
    ) %>%
      text("This message was sent from Shiny on {{ IP }} using {emayili}.") %>%
      smtp()
  })
}

shinyApp(ui = ui, server = server)

#' Specify content language
#'
#' Implements \href{https://datatracker.ietf.org/doc/html/rfc3282}{RFC 3282}.
#'
#' @noRd
content_language <- function(language, content) {
  if (is.na(language)) language <- FALSE

  if (is.logical(language)) {
    if (language) {
      # Auto-detect language.
      if (requireNamespace("cld3", quietly = TRUE)) {           # nocov start
        detect_language <- cld3::detect_language
      } else if (requireNamespace("cld2", quietly = TRUE)) {
        detect_language <- cld2::detect_language
      } else {
        stop("Unable to auto-detect language. Install {cld3} or {cld2}.")
      }                                                         # nocov end

      language <- detect_language(content)
    } else {
      # Don't include Content-Language.
      return(NULL)
    }
  } else {
    if (!is.character(language)) {
      stop("Language must either be a string or TRUE/FALSE.")   # nocov
    }
  }
  header("Content-Language", paste(language, collapse = ", "))
}

check_message_body <- function(content) {
  if (length(content) > 1) {
    stop("Only a single message body allowed.", call. = FALSE)
  }
}

#' Add a text body to a message.
#'
#' Add \code{text/plain} content to a message.
#'
#' The \code{text/plain} format is
#' described in \href{https://www.ietf.org/rfc/rfc2646.txt}{RFC 2646}.
#'
#' Uses \code{glue::glue()} to evaluate expressions enclosed in brackets as R code.
#'
#' @inheritParams mime-parameters
#' @param msg A message object.
#'
#' @return A message object.
#' @seealso \code{\link{html}}, \code{\link{render}}
#'
#' @export
#' @examples
#' msg <- envelope() %>% text("Hello!")
#'
#' # Using {glue} interpolation.
#' #
#' name <- "Alice"
#' msg <- envelope() %>% text("Hello {name}.")
#'
#' print(msg, details = TRUE)
#'
#' # Disable {glue} interpolation.
#' #
#' msg <- envelope() %>% text("This is a set: {1, 2, 3}.", interpolate = FALSE)
text <- function(
  msg,
  content,
  disposition = "inline",
  charset = "utf-8",
  encoding = "7bit",
  language = FALSE,
  interpolate = TRUE,
  .open = "{{",
  .close = "}}",
  .envir = NULL
) {
  check_message_body(content)

  if (is.null(.envir)) {
    .envir <- parent.frame()
  } else {
    .envir <- list2env(.envir)
  }

  if (interpolate) content <- glue(content, .open = .open, .close = .close, .envir = .envir)

  body <- text_plain(content, disposition, charset, encoding, language)

  msg <- append(msg, body)

  if (get_option_invisible()) invisible(msg) else msg # nocov
}

#' Transform a (tag)list to a character string
#'
#' @param content Element to transform.
#'
#' @return If the content is a list, a tagList or a tag,
#'     a character vector. Otherwise, it will return the
#'     input unchanged.
#'
#' @noRd
#' @examples
#' list_to_char(list("<b>Hello</b>", "<p>World!</p>"))
#' library(htmltools)
#' list_to_char(tagList(h2("Hello"), p("World!")))
list_to_char <- function(content) {
  if (
    # We do the change if the element is a
    # tag or a tag.list
    inherits(content, "shiny.tag.list") |
    inherits(content, "shiny.tag")
  ) {
    content <- as.character(content)
  }
  # Then if we have a list, we collapse it to
  # a character vector
  if (length(content) > 1) {
    content <- paste(content, collapse = "\n")
  }
  content
}

#' Add an HTML body to a message object.
#'
#' @inheritParams text
#' @param css_files Extra CSS files.
#' @return A message object.
#' @seealso \code{\link{text}}, \code{\link{render}}
#' @export
#' @examples
#' # Inline HTML message.
#' envelope() %>% html("<b>Hello!</b>")
#'
#' # Read HTML message from a file.
#' htmlfile <- tempfile(fileext = ".html")
#' cat("<p>Hello!</p>\n", file = htmlfile)
#' envelope() %>% html(htmlfile)
#'
#' # You can pass a vector of character. Components will be separated by a
#' # "\n".
#' envelope() %>% html(c("<b>Hello</b>", "<p>World!</p>"))
#'
#' # You can also pass a tagList from {htmltools}.
#' if (requireNamespace("htmltools", quietly = TRUE)) {
#'   library(htmltools)
#'   envelope() %>% html(tagList(h2("Hello"), p("World!")))
#' }
html <- function(
  msg,
  content,
  disposition = "inline",
  charset = "utf-8",
  encoding = "quoted-printable",
  css_files = c(),
  language = FALSE,
  interpolate = TRUE,
  .open = "{{",
  .close = "}}",
  .envir = NULL
) {
  content <- list_to_char(content)

  # Check if it's a file.
  #
  if (file.exists(content)) {
    content <- paste(readLines(content), collapse = "\n")
  }

  if (is.null(.envir)) {
    .envir <- parent.frame()
  } else {
    .envir <- list2env(.envir)
  }

  if (interpolate) content <- glue(content, .open = .open, .close = .close, .envir = .envir)

  body <- text_html(
    content, disposition, charset, encoding,
    css = read_text(css_files),
    language = language
  )

  msg <- append(msg, body)

  if (get_option_invisible()) invisible(msg) else msg # nocov
}

test_that("content-language field", {
  expect_match(
    envelope() %>% text("Hello!", language = "en-GB") %>% as.character(),
    "Content-Language: +en-GB"
  )
  expect_match(
    envelope() %>% html(HTMLCONTENT, language = "en-GB") %>% as.character(),
    "Content-Language: +en-GB"
  )
  expect_match(
    envelope() %>% render(RMD_TEMPLATE, language = "en-GB", include_css = FALSE) %>% as.character(),
    "Content-Language: +en-GB"
  )
})

test_that("detect language", {
  skip_if_neither_installed(c("cld3", "cld2"))
  expect_no_match(
    envelope() %>% text("Hello!", language = FALSE) %>% as.character(),
    "Content-Language:"
  )
  expect_match(
    envelope() %>%
      html(
        "<p>Hij heeft de klok horen luiden maar weet niet waar de klepel hangt.</p>",
        language = TRUE
      ) %>% as.character(),
    "Content-Language: +nl"
  )
})

test_that("text: only single message body", {
  expect_error(envelope() %>% text("<p>foo</p>"), NA)
  expect_error(envelope() %>% text(c("<p>foo</p>", "<p>bar</p>")))
})

test_that("list_to_char: tagList & vec of html are casted to character", {
  expect_equal(
    list_to_char(c("<b>Hello!</b>", "<p>World</p>")),
    "<b>Hello!</b>\n<p>World</p>"
  )
  skip_if_not_installed("htmltools")
  expect_equal(
    list_to_char(
      htmltools::tagList(
        htmltools::h2("this"),
        htmltools::p("That")
      )
    ),
    "<h2>this</h2>\n<p>That</p>"
  )
})

test_that("html: tagList & vec of html are cast to character", {
  msg <- envelope() %>% html(c("<b>Hello!</b>", "<p>World</p>"))
  expect_true(
    grepl(
      "<b>Hello!</b>",
      msg$parts[[1]]$content
    )
  )
  expect_true(
    grepl(
      "<p>World</p>",
      msg$parts[[1]]$content
    )
  )

  skip_if_not_installed("htmltools")
  msg <- envelope() %>% html(
    htmltools::tagList(
      htmltools::h2("Hello"),
      htmltools::p("World")
    )
  )

  expect_true(
    grepl(
      "<h2>Hello</h2>",
      msg$parts[[1]]$content
    )
  )
  expect_true(
    grepl(
      "<p>World</p>",
      msg$parts[[1]]$content
    )
  )
})

test_that("html: HTML from file", {
  expect_true(
    grepl(
      HTMLCONTENT,
      envelope() %>% html(HTMLPATH, encoding = NULL) %>% as.character()
    )
  )
})

test_that("disable interpolation", {
  expect_match(
    envelope() %>%
      text("Hello {{name}}!", interpolate = FALSE) %>%
      as.character(),
    "Hello \\{\\{name\\}\\}!"
  )
})

test_that("interpolate from environment", {
  variables <- list(name = "Alice")
  expect_match(
    envelope() %>%
      text("Hello {{name}}!", .envir = variables) %>%
      as.character(),
    "Hello Alice!"
  )
  expect_match(
    envelope() %>%
      html("<p>Hello {{name}}!</p>", .envir = variables) %>%
      as.character(),
    "Hello Alice!"
  )
})

test_that("interpolation delimeters", {
  name <- "Alice"
  expect_match(
    envelope() %>%
      text("Hello <<name>>!", .open = "<<", .close = ">>") %>%
      as.character(),
    "Hello Alice!"
  )
})

test_that("toggle visibility", {
  options(envelope.invisible = FALSE)
  expect_visible(envelope() %>% text("Hello!"))
  options(envelope.invisible = TRUE)
  expect_invisible(envelope() %>% text("Hello!"))
})

test_that("html: inject CSS", {
  expect_match(
    envelope() %>%
      html("<p>foo</p>", css_files = CSSPATH) %>%
      as.character(),
    COLOUR_GLAUCOUS
  )
})

test_that("Content-Type header", {
  expect_match(
    envelope() %>% text("Hello!") %>% as.character(),
    "Content-Type: +text/plain;[[:space:]]+charset=utf-8;[[:space:]]+format=flowed"
  )
})

test_that("envelope print() output", {
  msg <- envelope() %>% subject("Test message")
  expect_output(print(msg), "Date: +.*\nSubject: +Test message")
})

test_that("class envelope", {
  object <- envelope()
  expect_equal(class(object), "envelope")
})

test_that("recipient address", {
  recipient <- envelope(to = "bob@gmail.com")
  expect_equal(recipient$headers$To$values[[1]], address("bob@gmail.com"))
})

test_that("sender address", {
  sender <- envelope(from = "bob@gmail.com")
  expect_equal(sender$headers$From$values[[1]], address("bob@gmail.com"))
})

test_that("maximum one sender address", {
  expect_error(envelope(from = c("bob@gmail.com", "anne@example.com")))
  expect_error(envelope() %>% from(c("bob@gmail.com", "anne@example.com")))
})

test_that("cc", {
  cc <- envelope(cc = "bob@gmail.com")
  expect_equal(cc$headers$Cc$values[[1]], address("bob@gmail.com"))
})

test_that("bcc", {
  bcc <- envelope(bcc = "bob@gmail.com")
  expect_equal(bcc$headers$Bcc$values[[1]], address("bob@gmail.com"))
})

test_that("reply to", {
  reply <- envelope(reply = "bob@gmail.com")
  expect_equal(reply$header[["Reply-To"]]$values[[1]], address("bob@gmail.com"))
})

test_that("subject", {
  subject <- envelope(subject = "Email Subject")
  expect_equal(subject$header$Subject$values[[1]], "Email Subject")
})

test_that("body text", {
  email_text <- envelope(text = "foo")
  expect_equal(email_text$parts[[1]]$content, "foo")
})

test_that("body html", {
  html <- envelope(html = "<p>foo</p>")
  expect_match(html$parts[[1]]$content, "<body><p>foo</p></body>")
})

test_that("append another body", {
  msg <- envelope() %>% text("Hello!") %>% html("<p>Goodbye!</p>")
  expect_equal(length(msg$parts), 2)
})

test_that("parts are not nested", {
  msg <- envelope() %>%
    text("Hello!") %>%
    html(HTMLPATH) %>%
    attachment(JPGPATH)
  expect_false(is.nested(msg$parts))
})

msg <- envelope() %>%
  from(EMAIL_FROM) %>%
  to(EMAIL_TO)

msg_no_recipient <- envelope() %>%
  from(EMAIL_FROM)

msg_no_sender <- envelope() %>%
  to(EMAIL_TO)

test_that("server type", {
  expect_type(smtp, "closure")
  expect_type(smtp_sendgrid, "closure")
  expect_type(smtp_mailgun, "closure")
  expect_type(smtp_sendinblue, "closure")
  expect_type(smtp_mailersend, "closure")

  skip_if(suppressWarnings(is.na(smtp_gmail)))
  expect_type(smtp_gmail, "closure")
})

test_that("error if sender missing", {
  skip_on_cran()
  expect_error(smtp(msg_no_sender), "Must specify who the email is from.")
})

test_that("error if recipient missing", {
  skip_on_cran()
  expect_error(smtp(msg_no_recipient), "Must specify at least one email recipient.")
})

test_that("sends text message", {
  msg <- msg %>%
    subject("Text body") %>%
    text("Hello, World!")

  skip_on_cran()
  expect_error(smtp(msg), NA)
})

test_that("sends message with insecure = TRUE", {
  skip_on_cran()
  expect_error(smtp_insecure(msg), NA)
})

test_that("sends with SSL", {
  skip_on_cran()
  skip_on_ci()
  skip_if(suppressWarnings(is.na(smtp_gmail)))
  expect_error(smtp_gmail(msg %>% subject("{emayili} test")), NA)
})

test_that("sends HTML message", {
  msg <- msg %>%
    subject("HTML body") %>%
    html("<p><strong>Hello</strong>, <em>World</em>! You can also <u>underline</u> text.</p>")

  skip_on_cran()
  expect_error(smtp(msg), NA)
})

test_that("sends message with text attachment", {
  msg <- msg %>%
    attachment(TXTPATH)

  skip_on_cran()
  expect_error(smtp(msg %>% subject("{emayili} test: Text attachment")), NA)
})

test_that("sends message with image attachment", {
  msg <- msg %>%
    attachment(JPGPATH)

  skip_on_cran()
  expect_error(smtp(msg %>% subject("{emayili} test: Image attachment")), NA)
})

test_that("sends message with image attachment (using CID)", {
  msg <- msg %>%
    html('<img src="cid:r-logo"/>') %>%
    attachment(JPGPATH, cid = "r-logo", type = "image/jpg")

  skip_on_cran()
  expect_error(smtp(msg %>% subject("{emayili} test: Image attachment (using CID)")), NA)
})

test_that("verbose output", {
  skip_on_cran()

  expect_match(
    capture.output(smtp(msg, verbose = TRUE), type = "message") %>%
      paste(collapse = "\n"),
    "250 Message accepted",
    fixed = TRUE
  )

  expect_length(capture.output(smtp(msg), type = "message"), 0)
})

test_that("replace bare line feeds", {
  msg <- envelope() %>% render("Hello!")

  expect_false(as.character(msg) %>% str_detect(REGEX_BARE_LINEFEED))
})

skip_if_not_installed("gpg")
#
# Encryption tests currently don't work with macOS on GitHub Actions.
#
skip_on_os(os = "mac")

library(gpg)

# - If running locally then use random home directory for keyring.
# - Don't do this on CI because GPG doesn't work on macOS with non-default
#   home folder.
#
if (Sys.getenv("CI") == "") {
  message("Use random home folder for GPG.")
  gpg_restart(home = tempdir(), silent = TRUE)
}
#
gpg_keygen(name = "Alice", email = "alice@yahoo.com")
gpg_keygen(name = "Bob", email = "bob@gmail.com")
gpg_keygen(name = "Jim", email = "jim@aol.com")
#
# The keys should all be RSA.
#
stopifnot(all(gpg_list_keys() %>% pull(algo) %in% c("RSA", "EdDSA")))

BEGIN_PGP_MESSAGE          = "-----BEGIN PGP MESSAGE-----"
END_PGP_MESSAGE            = "-----END PGP MESSAGE-----"
BEGIN_PGP_SIGNATURE        = "-----BEGIN PGP SIGNATURE-----"
END_PGP_SIGNATURE          = "-----END PGP SIGNATURE-----"
BEGIN_PGP_PUBLIC_KEY_BLOCK = "-----BEGIN PGP PUBLIC KEY BLOCK-----"
END_PGP_PUBLIC_KEY_BLOCK   = "-----END PGP PUBLIC KEY BLOCK-----"

test_that("sign/encrypt empty message", {
  msg <- envelope(
    to = "alice@yahoo.com",
    from = "bob@gmail.com",
    encrypt = TRUE,
    sign = TRUE
  )

  expect_error(as.character(msg))
})

test_that("sign", {
  msg <- envelope(
    to = "alice@yahoo.com",
    from = "bob@gmail.com",
    sign = TRUE
  ) %>% text(TXTCONTENT)

  expect_match(as.character(msg), BEGIN_PGP_SIGNATURE)
  expect_match(as.character(msg), END_PGP_SIGNATURE)

  expect_no_match(as.character(msg), BEGIN_PGP_MESSAGE)
  expect_no_match(as.character(msg), END_PGP_MESSAGE)
  expect_no_match(as.character(msg), BEGIN_PGP_PUBLIC_KEY_BLOCK)
  expect_no_match(as.character(msg), END_PGP_PUBLIC_KEY_BLOCK)
})

test_that("encrypt", {
  msg <- envelope(
    to = "alice@yahoo.com",
    from = "bob@gmail.com",
    encrypt = TRUE
  ) %>% text(TXTCONTENT)

  expect_match(as.character(msg), BEGIN_PGP_MESSAGE)
  expect_match(as.character(msg), END_PGP_MESSAGE)

  expect_no_match(as.character(msg), BEGIN_PGP_SIGNATURE)
  expect_no_match(as.character(msg), END_PGP_SIGNATURE)
  expect_no_match(as.character(msg), BEGIN_PGP_PUBLIC_KEY_BLOCK)
  expect_no_match(as.character(msg), END_PGP_PUBLIC_KEY_BLOCK)
})

test_that("sign & encrypt", {
  msg <- envelope(
    to = "alice@yahoo.com",
    from = "bob@gmail.com",
    sign = TRUE,
    encrypt = TRUE
  ) %>% text(TXTCONTENT)

  expect_match(as.character(msg), BEGIN_PGP_MESSAGE)
  expect_match(as.character(msg), END_PGP_MESSAGE)

  expect_no_match(as.character(msg), BEGIN_PGP_SIGNATURE)
  expect_no_match(as.character(msg), END_PGP_SIGNATURE)
  expect_no_match(as.character(msg), BEGIN_PGP_PUBLIC_KEY_BLOCK)
  expect_no_match(as.character(msg), END_PGP_PUBLIC_KEY_BLOCK)
})

test_that("public key", {
  msg <- envelope(
    to = "alice@yahoo.com",
    from = "bob@gmail.com",
    public_key = TRUE
  ) %>% text(TXTCONTENT)

  expect_match(as.character(msg), BEGIN_PGP_PUBLIC_KEY_BLOCK)
  expect_match(as.character(msg), END_PGP_PUBLIC_KEY_BLOCK)

  expect_no_match(as.character(msg), BEGIN_PGP_SIGNATURE)
  expect_no_match(as.character(msg), END_PGP_SIGNATURE)
  expect_no_match(as.character(msg), BEGIN_PGP_MESSAGE)
  expect_no_match(as.character(msg), END_PGP_MESSAGE)
})

test_that("fail without sender or recipients", {
  expect_error(
    envelope(to = "alice@yahoo.com") %>% encrypt() %>% as.character(),
    "without sender"
    )
  expect_error(
    envelope(from = "bob@gmail.com") %>% encrypt() %>% as.character(),
    "without recipients"
    )
})

test_that("missing public keys", {
  # Missing sender key.
  expect_error(
    envelope(to = "alice@yahoo.com", from = "tim@gmail.com") %>%
      encrypt() %>% as.character(),
    "missing keys",
    ignore.case = TRUE
  )
  # Missing recipient key.
  expect_error(
    envelope(to = "jenny@yahoo.com", from = "bob@gmail.com") %>%
      encrypt() %>% as.character(),
    "missing keys",
    ignore.case = TRUE
  )
})

test_that("sign with/without body", {
  nobody <- envelope(to = "alice@yahoo.com", from = "bob@gmail.com")
  body <- nobody %>% text("Hello!")

  # With public key.
  expect_error(nobody %>% encrypt(FALSE, TRUE, TRUE) %>% as.character(), NA)
  expect_error(body %>% encrypt(FALSE, TRUE, TRUE) %>% as.character(), NA)

  # Without public key.
  expect_error(nobody %>% encrypt(FALSE, TRUE, FALSE) %>% as.character(), "empty message")
  expect_error(body %>% encrypt(FALSE, TRUE, FALSE) %>% as.character(), NA)
})

#' Create a SMTP server object.
#'
#' @name server
#'
#' @param host DNS name or IP address of the SMTP server.
#' @param port Port that the SMTP server is listening on.
#' @param username Username for SMTP server.
#' @param password Password for SMTP server or API key.
#' @param insecure Whether to ignore SSL issues.
#' @param reuse Whether the connection to the SMTP server should be left open for reuse.
#' @param helo The HELO domain name of the sending host. If left as \code{NA} then will use local host name.
#' @param protocol Which protocol (SMTP or SMTPS) to use for communicating with
#'   the server. Default will choose appropriate protocol based on port.
#' @param max_times Maximum number of times to retry.
#' @param pause_base Base delay (in seconds) for exponential backoff. See \link[purrr]{rate_backoff}.
#' @param ... Additional curl options. See \code{curl::curl_options()} for a list of supported options.
#'
#' @return A function which is used to send messages to the server.
#' @export
#' @examples
#' # Set parameters for SMTP server (with username and password).
#' smtp <- server(
#'   host = "smtp.gmail.com",
#'   port = 587,
#'   username = "bob@gmail.com",
#'   password = "bd40ef6d4a9413de9c1318a65cbae5d7"
#' )
#'
#' # Set parameters for a (fake) testing SMTP server.
#' #
#' # More information about this service can be found at https://www.smtpbucket.com/.
#' #
#' smtp <- server(
#'   host = "mail.smtpbucket.com",
#'   port = 8025
#' )
#'
#' # Create a message
#' msg <- envelope() %>%
#'   from("bob@gmail.com") %>%
#'   to("alice@yahoo.com")
#'
#' # Send message (verbose output from interactions with server)
#' \dontrun{
#' smtp(msg, verbose = TRUE)
#' }
#'
#' # To confirm that the message was sent, go to https://www.smtpbucket.com/ then:
#' #
#' # - fill in "bob@gmail.com" for the Sender field and
#' # - fill in "alice@yahoo.com" for the Recipient field then
#' # - press the Search button.
#'
#' # With explicit HELO domain.
#' #
#' smtp <- server(host = "mail.example.com",
#'                helo = "client.example.com")
server <- function(
  host,
  port = 25,
  username = NULL,
  password = NULL,
  insecure = FALSE,
  reuse = TRUE,
  helo = NA,
  protocol = NA,
  pause_base = 1,
  max_times = 5,
  ...) {
  function(msg, verbose = FALSE) {
    debugfunction <- if (verbose) function(type, msg) cat(readBin(msg, character()), file = stderr()) # nocov

    if (is.null(from(msg))) stop("Must specify who the email is from.")

    recipients <- c(to(msg), cc(msg), bcc(msg))
    #
    if (length(recipients) < 1) stop("Must specify at least one email recipient.")

    # See curl::curl_options() for available options.
    #
    # * SSL
    #
    # - If you get the "The certificate chain was issued by an authority that is not trusted." error then
    #   can add in ssl_verifypeer = FALSE.
    # - Other flags:
    #
    #   - ssl_verifyhost
    #   - ssl_verifypeer
    #   - ssl_verifystatus
    #
    #   Run curl_options('ssl') to see other options.
    #
    if (insecure) {
      ssl_verifypeer = FALSE
    } else {
      ssl_verifypeer = TRUE
    }

    port <- as.integer(port)
    if (port %in% c(465, 587)) {
      use_ssl = 1
    } else {
      use_ssl = 0
    }

    smtp_server <- smtp_url(host, port, protocol, helo)
    #
    if (verbose) {
      log_debug("Sending email to ", smtp_server, ".")
    }

    # Create an insistent version of send_mail().
    #
    # This is to mitigate occasional curl_fetch_memory() errors.
    #
    if (max_times > 1) {
      send_mail <- insistently(
        send_mail,
        rate = rate_backoff(
          max_times = max_times,
          pause_base = pause_base,
          pause_cap = pause_base * 2**max_times,
          jitter = FALSE
        )
      )
    }

    result <- send_mail(
      # Strip descriptive name (retained in email header so that it appears
      # in email client).
      mail_from = raw(from(msg)),
      mail_rcpt = raw(recipients),
      # Get character representation of envelope object.
      message = as.character(msg),
      smtp_server = smtp_server,
      username = username,
      password = password,
      verbose = verbose,
      debugfunction = debugfunction,
      ssl_verifypeer = ssl_verifypeer,
      use_ssl = use_ssl,
      forbid_reuse = !reuse,
      ...
    )

    invisible(result)
  }
}

#' @rdname server
#'
#' @export
#'
#' @examples
#'
#' # Set parameters for Gmail SMTP server. The host and port are implicit.
#' smtp <- gmail(
#'   username = "bob@gmail.com",
#'   password = "bd40ef6d4a9413de9c1318a65cbae5d7"
#' )
gmail <- function(
  username,
  password,
  ...) {
  # Retrieve function.
  fcall <- match.call(expand.dots = TRUE)
  # Substitute server() as function to call.
  fcall[[1]] <- server
  # Fill in host and port arguments.
  fcall$host = "smtp.gmail.com"
  fcall$port = ifelse(is.null(fcall$port), 587, fcall$port)
  # Now run the function call.
  eval(fcall, parent.frame())
}

#' @rdname server
#'
#' @section Sendgrid:
#'
#' To use SendGrid you'll need to first \href{https://docs.sendgrid.com/for-developers/sending-email/integrating-with-the-smtp-api}{create an API key}.
#' Then use the API key as the password.
#'
#' SendGrid will accept messages on ports 25, 587 and 2525 (using SMTP) as well
#' as 465 (using SMTPS).
#'
#' @export
#'
#' @examples
#'
#' # Set API key for SendGrid SMTP server.
#' smtp <- sendgrid(
#'   password = "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"
#' )
sendgrid <- function(
  password,
  ...) {
  fcall <- match.call(expand.dots = TRUE)

  fcall[[1]] <- server
  fcall$host = "smtp.sendgrid.net"
  fcall$port = ifelse(is.null(fcall$port), 587, fcall$port)
  fcall$username = "apikey"

  eval(fcall, parent.frame())
}

#' @rdname server
#'
#' @section Mailgun:
#'
#' To use Mailgun you'll need to first register a sender domain. This will then
#' be assigned a username and password.
#'
#' Mailgun will accept messages on ports 25 and 587 (using SMTP) as well as 465
#' (using SMTPS).
#'
#' @export
#'
#' @examples
#'
#' # Set username and password for Mailgun SMTP server.
#' smtp <- mailgun(
#'   username = "postmaster@sandbox9ptce35fdf0b31338dec4284eb7aaa59.mailgun.org",
#'   password = "44d072e7g2b5f3bf23b2b642da0fe3a7-2ac825a1-a5be680a"
#' )
mailgun <- function(
  username,
  password,
  ...) {
  fcall <- match.call(expand.dots = TRUE)

  fcall[[1]] <- server
  fcall$host = "smtp.mailgun.org"
  fcall$port = ifelse(is.null(fcall$port), 587, fcall$port)

  eval(fcall, parent.frame())
}

#' @rdname server
#'
#' @section Sendinblue:
#'
#' To use Sendinblue you'll need to first create an account. You'll find your
#' SMTP username and password in the SMTP & API section of your account
#' settings.
#'
#' @export
#'
#' @examples
#'
#' # Set username and password for Sendinblue SMTP server.
#' smtp <- sendinblue(
#'   username = "bob@gmail.com",
#'   password = "xsmtpsib-c75cf91323adc53a1747c005447cbc9a893c35888635bb7bef1a624bf773da33"
#' )
sendinblue <- function(
  username,
  password,
  ...) {
  fcall <- match.call(expand.dots = TRUE)

  fcall[[1]] <- server
  fcall$host = "smtp-relay.sendinblue.com"
  fcall$port = 587

  eval(fcall, parent.frame())
}

#' @rdname server
#'
#' @section MailerSend:
#'
#' To use MailerSend you'll need to first create an account. You'll find your
#' SMTP username and password under Domains. See \href{https://www.mailersend.com/help/smtp-relay}{How to send emails via SMTP with MailerSend}.
#'
#' Although this is not likely to be a problem in practice, MailerSend insists
#' that all messages have at minimum a valid subject and either text or HTML
#' content.
#'
#' @export
#'
#' @examples
#'
#' # Set username and password for MailerSend SMTP server.
#' smtp <- mailersend(
#'   username = "NS_Pf3ALM@gmail.com",
#'   password = "e5ATWLlTnWWDaKeE"
#' )
mailersend <- function(
  username,
  password,
  ...) {
  fcall <- match.call(expand.dots = TRUE)

  fcall[[1]] <- server
  fcall$host = "smtp.mailersend.net"
  fcall$port = 587

  eval(fcall, parent.frame())
}

manifest <- function(
  markdown,
  params = NULL,
  squish = TRUE,
  css,
  include_css,
  language
) {
  stopifnot(is.null(params) || is.list(params))

  if (plain <- attr(markdown, "plain")) {
    output <- markdown_html(markdown) %>% read_html()
  } else {
    # Create temporary Rmd file.
    #
    # This needs to be in the current directory in case the Rmd is accessing
    # files (like CSV) using a relative path.
    #
    input <- tempfile(fileext = ".Rmd", tmpdir = getwd())

    # Clean up rendered artefacts.
    #
    on.exit(unlink(sub("\\.Rmd", "*", input), recursive = TRUE))

    # Write input to file.
    cat(markdown, file = input)

    output <- sub("\\.Rmd", ".html", input)
    image_path <- file.path(sub("\\.Rmd", "_files", input), "figure-html")

    output_format <- html_document(
      # Inline images don't work with GMail web client.
      self_contained = FALSE
    )

    output_format$knitr$knit_hooks <- list(
      plot = function(x, options) {
        caption <- options$fig.cap
        alt <- options$fig.alt
        if (is.null(alt)) alt <- caption
        class <- options$fig.class
        width <- options$out.width

        as.character(
          tags$figure(
            tags$img(
              src = x,
              alt = alt,
              width = width
            ),
            if(is.null(caption)) NULL else tags$figcaption(caption),
            class = class
          )
        )
      }
    )

    # Render from file to file.
    rmarkdown::render(
      input,
      output_format = output_format,
      output_file = output,
      params = params,
      quiet = TRUE,
      # Pass a clean environment. This makes it possible to use params name in
      # this scope.
      envir = new.env()
    )

    # Read output from file.
    output <- read_html(output)

    # Extract CSS from <link> and <style> tags and append.
    #
    css <- c(
      # * Inline CSS in <link> tags.
      if (any("rmd" == include_css)) {
        inline = xml_find_all(output, "//link[starts-with(@href,'data:text/css')]") %>%
          xml_attr("href") %>%
          unlist() %>%
          url_decode() %>%
          str_replace("data:text/css,", "")
      } else NULL,
      # * External CSS in <link> tags.
      #
      # This is CSS for:
      #
      # - Bootstrap and
      # - highlight.js.
      #
      external = xml_find_all(output, "//link[not(starts-with(@href,'data:text/css'))]") %>%
        xml_attr("href") %>%
        map(function(path) {
          include_css <- setdiff(include_css, "rmd")
          # Check is CSS path matches one of the requested options.
          if (length(include_css)) {
            if (str_detect(path, paste0("/", include_css, collapse = "|"))) path else NULL
          } else NULL
        }) %>%
        unlist() %>%
        file.path(dirname(input), .) %>%
        map_chr(read_text),
      # * Inline CSS in <style> tags.
      if (any("rmd" == include_css)) {
        style = xml_find_all(output, "//style") %>%
          xml_text() %>%
          unlist()
      } else NULL,
      # * Add custom CSS rules last so that it overrides preceding rules.
      css
    )

    # Delete <script>, <link>, <style> and <meta> tags.
    #
    xml_find_all(output, "//script | //link | //style | //meta") %>% xml_remove()

    # Remove comments.
    #
    xml_find_all(output, "//comment()") %>% xml_remove()

    # Convert image links into CID references.
    #
    for (img in xml_find_all(output, "//img")) {
      src <- xml_attr(img, "src")
      # Check for Base64 encoded inline image.
      if (!str_detect(src, "^data:image")) {
        xml_attr(img, "src") <- paste0('cid:', hexkey(basename(src)))
      }
    }

    body <- multipart_related()

    # Attach images with appropriate CID.
    #
    for (image in list.files(image_path, full.names = TRUE)) {
      body <- append(
        body,
        other(
          filename = image,
          cid = hexkey(basename(image)),
          disposition = "inline"
        )
      )
    }
  }

  # Remove all other tags in <head>
  xml_find_all(output, "//head/*") %>% xml_remove()

  output <- as.character(output) %>%
    # Remove <!DOCTYPE> tag.
    str_replace("[:space:]*<!DOCTYPE html>[:space:]*", "") %>%
    # Remove <meta> tag (a "Content-Type" <meta> inserted by {xml2}).
    str_replace("<meta[^>]*>", "")

  output <- text_html(output, squish = squish, css = css, language = language)

  if (plain) {
    output
  } else {
    prepend(body, output)
  }
}

# If {memoise} is installed then memoise manifest().
#
if (requireNamespace("memoise", quietly = TRUE)) {
  manifest <- memoise::memoise(manifest)
}

#' Render Markdown into email
#'
#' @description
#'
#' Render either Plain Markdown or R Markdown directly into the body of an email.
#'
#' If \code{input} is a file then it will be interpreted as R Markdown it its
#' extension is either \code{"Rmd"} or \code{"Rmarkdown"}. Otherwise it will be
#' processed as Plain Markdown.
#'
#' @section Plain Markdown:
#'
#' Plain Markdown is processed with [commonmark::markdown_html()].
#'
#' @section R Markdown:
#'
#' R Markdown is processed with [rmarkdown::render()].
#'
#' Regardless of what \code{output} type is specified in the input file,
#' \code{render()} will always use the \code{"html_document"} output format.
#'
#' @inheritParams text
#' @inheritParams html
#' @param msg A message object.
#' @param input The input Markdown file to be rendered or a character vector of Markdown text.
#' @param params A list of named parameters that override custom parameters specified in the YAML front-matter.
#' @param squish Whether to clean up whitespace in rendered document.
#' @param include_css Whether to include rendered CSS from various sources (\code{"rmd"} — native R Markdown CSS; \code{"bootstrap"} — Bootstrap CSS; \code{"highlight"} — highlight.js CSS).
#'
#' @return A message object.
#' @seealso \code{\link{text}}, \code{\link{html}}
#' @export
#'
#' @examples
#'
#' # Plain Markdown
#'
#' markdown <- "[This](https://www.google.com) is a link."
#' filename <- "message.md"
#'
#' # Render from Markdown in character vector.
#' msg <- envelope() %>% render(markdown)
#'
#' # Create a file containing Markdown
#' cat(markdown, file = filename)
#'
#' # Render from Markdown in file.
#' msg <- envelope() %>% render(filename)
#'
#' # Cleanup.
#' file.remove(filename)
#'
#' # R Markdown
#'
#' filename <- "gh-doc.Rmd"
#'
#' # Create an Rmd document from template.
#' rmarkdown::draft(
#'   filename,
#'   template = "github_document",
#'   package = "rmarkdown",
#'   edit = FALSE
#' )
#'
#' # Check for suitable version of Pandoc (https://pandoc.org/).
#' #
#' # Need to have version 2.0 or greater to support required --quiet option.
#' #
#' pandoc <- rmarkdown::find_pandoc()
#' suitable_pandoc <- !is.null(pandoc$dir) && grepl("^2", pandoc$version)
#'
#' # Render from Rmd file.
#' if (suitable_pandoc) {
#'   msg <- envelope() %>%
#'     render(filename, include_css = c("rmd", "highlight"))
#' }
#'
#' # Cleanup.
#' file.remove(filename)
render <- function(
  msg,
  input,
  params = NULL,
  squish = TRUE,
  css_files = c(),
  include_css = c("rmd", "bootstrap", "highlight"),
  language = FALSE,
  interpolate = TRUE,
  .open = "{{",
  .close = "}}",
  .envir = NULL
) {
  stopifnot(is.envelope(msg))
  stopifnot(is.logical(interpolate))
  stopifnot(is.character(.open))
  stopifnot(is.character(.close))
  stopifnot(!length(css_files) || is.character(css_files))

  INCLUDE_CSS_OPTIONS <- eval(formals(render)$include_css)

  # Translate Boolean include_css:
  #
  # TRUE  - all CSS
  # FALSE - no CSS).
  #
  if (is.logical(include_css) && length(include_css) == 1) {
    include_css <- if(include_css) INCLUDE_CSS_OPTIONS else NULL
  }

  if (length(setdiff(include_css, INCLUDE_CSS_OPTIONS)) > 0) {
    stop(
      "Valid options for include_css are: ",
      paste(INCLUDE_CSS_OPTIONS, collapse = ", "),
      "."
      )
  }

  if (is.null(.envir)) .envir = parent.frame()
  else .envir = list2env(.envir) # nocov

  if (is_filepath(input)) {
    log_debug("Interpreting input as path to file.")
    plain <- !(file_ext(input) %in% c("Rmd", "Rmarkdown"))
    markdown <- read_text(input)
  } else {
    log_debug("Interpreting input as character vector.")
    plain <- TRUE
    markdown <- input
  }
  log_debug("Assuming input is ", ifelse(plain, "Plain", "R"), " Markdown.")

  if (interpolate) {
    markdown <- glue(markdown, .open = .open, .close = .close, .envir = .envir)
  }

  if (markdown == "") stop("Input is empty!")

  attr(markdown, "plain") <- plain

  body <- manifest(
    markdown,
    params,
    squish,
    list(extra = read_text(css_files)),
    include_css,
    language
  )

  msg <- append(msg, body)

  if (get_option_invisible()) invisible(msg) else msg # nocov
}

skip_on_os(os = c("mac", "windows", "solaris"))

# To ensure that these locales are supported you might need to run this in the
# shell:
#
# sudo locale-gen es_ES es_ES.utf8
# sudo update-locale

check_render <- function(locale, unicode, txt) {
  test_that(locale, {
    # Write text to file in a UTF8 locale. This ensures that the accented
    # characters are rendered correctly to the file on disk.
    Sys.setlocale("LC_ALL", "en_US.UTF-8")
    md <- tempfile()
    cat(txt, file = md)

    # Change to other locale.
    Sys.setlocale("LC_ALL", locale)
    local_reproducible_output(unicode = unicode)

    # Render from string.
    expect_match(envelope() %>% render(txt) %>% as.character(), txt)

    # Render from file.
    expect_match(envelope() %>% render(md) %>% as.character(), txt)
  })
}

# Get current locale.
#
CURRENT_LOCALE = Sys.getlocale("LC_CTYPE")

# Spanish
#
ES_TXT <- "Desde el comité organizador"
#
check_render("es_ES.utf8", TRUE, ES_TXT)
check_render("Spanish", FALSE, ES_TXT)

# Restore locale.
#
Sys.setlocale("LC_ALL", CURRENT_LOCALE)

LEVELS_SENSITIVITY <- c("personal", "private", "company-confidential")

#' Set or query message sensitivity
#'
#' Manipulate the \code{Sensitivity} field as specified in \href{https://www.ietf.org/rfc/rfc2156.txt}{RFC 2156}.
#'
#' @param msg A message object.
#' @param sensitivity Sensitivity level. One of \code{"personal"}, \code{"private"}, or \code{"company-confidential"}.
#' @return A message object.
#'
#' @export
#'
#' @examples
#' # Not sensitive.
#' envelope() %>%
#'   subject("Your daily dose of spam")
#'
#' # Sensitive personal message.
#' envelope() %>%
#'   subject("The results from your test") %>%
#'   sensitivity("personal")
#'
#' # Sensitive private message.
#' envelope() %>%
#'   subject("Your OTP (don't show this to anybody!") %>%
#'   sensitivity("private")
#'
#' # Sensitive business message.
#' envelope() %>%
#'   subject("Top Secret Strategy Document") %>%
#'   sensitivity("company-confidential")
#'
sensitivity <- function(msg, sensitivity = NULL) {
  if (is.null(sensitivity)) {
    header_get(msg, "Sensitivity")
  } else {
    if (!(sensitivity %in% LEVELS_SENSITIVITY)) {
      stop("Invalid sensitivity Options are: ", paste(LEVELS_SENSITIVITY, collapse = ", "), ".")
    }

    msg <- header_set(msg, "Sensitivity", sensitivity, append = FALSE)

    if (get_option_invisible()) invisible(msg) else msg # nocov
  }
}

#' Encrypt or sign a message
#'
#' Specify whether the message should be encrypted, signed or have a public key attached.
#'
#' If a recipient's email client is unable to decrypt an encrypted message then they will not be able to access the message contents.
#'
#' @inheritParams envelope
#' @inheritParams parties
#'
#' @return A message object.
#' @export
#'
#' @examples
#' \dontrun{
#' msg <- envelope(
#'   to = "schunk@u-boat.com",
#'   subject = "Top Secret Message",
#'   text = "Immediate readiness. There are indications that the invasion has begun."
#' )
#' msg %>% encrypt()
#' }
encrypt <- function(msg, encrypt = TRUE, sign = TRUE, public_key = TRUE) {
  encrypt <- ifelse(is.null(encrypt), FALSE, encrypt)           # nocov start
  sign <- ifelse(is.null(sign), FALSE, sign)
  stopifnot(is.logical(encrypt) && is.logical(sign))

  msg$encrypt <- encrypt
  msg$sign <- sign
  msg$public_key <- public_key                                  # nocov end

  if (get_option_invisible()) invisible(msg) else msg # nocov
}

encrypt_body <- function(content, parties, encrypt, sign, public_key) {
  encrypt <- ifelse(is.null(encrypt), FALSE, encrypt)
  sign <- ifelse(is.null(sign), FALSE, sign)

  # - Can't encrypt or sign an empty message...
  # - ... unless that message just contains a public key.
  if ((encrypt || sign) && is.null(content) && !public_key) stop("Can't sign or encrypt an empty message!")

  if (encrypt || sign || public_key) {
    if(!requireNamespace("gpg", quietly = TRUE)) {
      stop("Install {gpg} to encrypt and/or sign messages.")    # nocov
    }
    log_debug("Encrypt message: {encrypt}")
    log_debug("Sign message:    {sign}")

    parties <- parties %>% select(type, email = raw)

    sender <- parties %>% filter(type == "From")
    if (!nrow(sender)) stop("Can't sign or encrypt without sender!")
    recipients <- parties %>% anti_join(sender, by = c("type", "email"))
    if (!nrow(recipients)) stop("Can't sign or encrypt without recipients!")

    keys <- gpg::gpg_list_keys()

    missing_keys <- anti_join(parties, keys, by = "email")

    if (nrow(missing_keys)) {
      stop("Missing keys for the follow addresses: ", paste(missing_keys$email, collapse = ", "), ".")
    }

    # Get the fingerprints of the senders' keys.
    #
    sender_fingerprint <- keys %>%
      inner_join(sender, by = "email") %>%
      pull(fingerprint)

    # Get the fingerprints of the recipients' keys.
    #
    recipients_fingerprint <- keys %>%
      inner_join(recipients, by = "email") %>%
      pull(fingerprint)

    TMPFILE <- tempfile()

    if (sign || public_key) {
      if (!("multipart_mixed" %in% class(content))) {
        if (is.null(content)) {
          log_debug("Create empty multipart/mixed.")
          content <- multipart_mixed()
        } else {
          log_debug("Convert message to multipart/mixed.")
          content <- multipart_mixed(
            children = list(content)
          )
        }
      }
    }

    if (public_key) {
      if (public_key) {
        log_debug("Export public key.")
        public_key <- gpg::gpg_export(sender_fingerprint)
        log_debug("Done!")
        log_debug("Append public key.")
        content <- append.MIME(content, application_pgp_keys(public_key))
      }
    }

    # - Sign content from temporary file.
    # - Write result back to temporary file.
    #
    if (sign) {
      log_debug("Write message to {TMPFILE}.")
      cat(as.character.MIME(content), file = TMPFILE)
      log_debug("Sign message from {TMPFILE}.")
      signature <- gpg::gpg_sign(TMPFILE, sender_fingerprint, mode = "detach")
      log_debug("Done!")
      log_debug("Add signature.")
      signed <- multipart_signed(
        children = list(
          content,
          application_pgp_signature(signature)
        )
      )
      log_debug("Write multipart/signed message to {TMPFILE}.")
      as.character.MIME(signed) %>% writeLines(TMPFILE)
    } else {
      log_debug("Write message to {TMPFILE}.")
      as.character.MIME(content) %>% writeLines(TMPFILE)
    }

    # - Encrypt content from temporary file.
    # - Write result back to temporary file.
    #
    if (encrypt) {
      log_debug("Encrypt message from {TMPFILE}.")
      # Don't sign here because signature is handled separately.
      encrypted <- gpg::gpg_encrypt(TMPFILE, recipients_fingerprint, signer = NULL)
      log_debug("Done!")
      encrypted <- multipart_encrypted(
        children = list(
          application_pgp_encrypted(),
          application_octet_stream(
            encrypted,
            disposition = "inline",
            filename = "encrypted.asc"
          )
        )
      )
      log_debug("Write multipart/encrypted message to {TMPFILE}.")
      as.character.MIME(encrypted) %>% writeLines(TMPFILE)
    }

    log_debug("Read message from {TMPFILE}.")
    content <- read_text(TMPFILE)

    # Delete temporary file.
    #
    unlink(TMPFILE)
  }

  content
}

get_option_invisible <- function(default = TRUE) {
  getOption("envelope.invisible", default = default)
}

get_option_details <- function(default = TRUE) {
  getOption("envelope.details", default = default)
}

library(hexSticker)
library(showtext)

# Load Google font.
#
font_add_google("Roboto Slab", "roboto_slab")
showtext_auto()

sticker(here::here("inst/hex/envelope-regular.png"),
        # Image
        s_x = 1,
        s_y = 1.10,
        s_width = 0.6,
        s_height = 0.6,
        # Package name
        package = "{emayili}",
        p_size = 16,
        p_y = 0.45,
        p_color = "#ffffff",
        p_family = "roboto_slab",
        # Hex
        h_fill = "#3498db",
        h_color = "#000000",
        # Output
        filename = here::here("man/figures/emayili-hex.png"),
        dpi = 300
)

is.envelope <- function(x) {
  "envelope" %in% class(x)
}

#' Create a message.
#'
#' @param to See [to()].
#' @param from See [from()].
#' @param cc See [cc()].
#' @param bcc See [bcc()].
#' @param reply See [reply()].
#' @param subject See [subject()].
#' @param importance See [importance()].
#' @param priority See [priority()].
#' @param text See [text()].
#' @param html See [html()].
#' @param encrypt Whether to encrypt the message. If \code{TRUE} then the entire
#'   message will be encrypted using the private key of the sender.
#' @param sign Whether to sign the message. If \code{TRUE} then the entire message will be signed using the private key of the sender.
#' @param public_key Whether to attach a public key. If \code{TRUE} then the public key of the sender will be attached.
#'
#' @return A message object.
#' @seealso [subject()], [from()], [to()], [cc()], [bcc()], [reply()] and
#'   [encrypt()].
#' @export
#' @examples
#' # Create an (empty) message object.
#' #
#' msg <- envelope()
#'
#' # Create a complete message object, specifying all available fields.
#' #
#' envelope(
#'   to = "bob@gmail.com",
#'   from = "craig@gmail.com",
#'   cc = "alex@gmail.com",
#'   bcc = "shannon@gmail.com",
#'   reply = "craig@yahoo.com",
#'   importance = "high",
#'   priority = "urgent",
#'   subject = "Hiya!",
#'   text = "Hi Bob, how are you?"
#' )
envelope <- function(
  to = NULL,
  from = NULL,
  cc = NULL,
  bcc = NULL,
  reply = NULL,
  subject = NULL,
  importance = NULL,
  priority = NULL,
  text = NULL,
  html = NULL,
  encrypt = FALSE,
  sign = FALSE,
  public_key = FALSE
) {
  koevert <- structure(
    list(
      headers = list(),
      encrypt = encrypt,
      sign = sign,
      public_key = public_key,
      parts = NULL
    ),
    class="envelope"
  ) %>%
    header_set("Date", http_date(Sys.time()), append = FALSE) %>%
    header_set("X-Mailer", paste("{emayili}", packageVersion("emayili"), sep = "-"), append = FALSE) %>%
    header_set("MIME-Version", "1.0", append = FALSE)

  if (!is.null(to)) koevert <- to(koevert, to)
  if (!is.null(from)) koevert <- from(koevert, from)
  if (!is.null(cc)) koevert <- cc(koevert, cc)
  if (!is.null(bcc)) koevert <- bcc(koevert, bcc)
  if (!is.null(reply)) koevert <- reply(koevert, reply)
  if (!is.null(subject)) koevert <- subject(koevert, subject)
  if (!is.null(importance)) koevert <- importance(koevert, importance)
  if (!is.null(priority)) koevert <- priority(koevert, priority)
  if (!is.null(text)) koevert <- text(koevert, text)
  if (!is.null(html)) koevert <- html(koevert, html)

  koevert
}

headers <- function(x) {
  paste(sapply(x$headers, as.character), collapse = "\r\n")
}

#' Print a message object
#'
#' The message body will be printed if `details` is `TRUE` or if the `envelope_details`
#' option is `TRUE`.
#'
#' @param x A message object.
#' @param details Whether or not to display full message content.
#' @param ... Further arguments passed to or from other methods.
#'
#' @export
#' @examples
#' msg <- envelope() %>% text("Hello, World!")
#'
#' print(msg)
#' print(msg, details = TRUE)
#'
#' options(envelope_details = TRUE)
#' print(msg)
print.envelope <- function(x, details = NA, ...) {
  if (is.na(details)) {
    details = get_option_details(default = FALSE)
  }
  stopifnot(is.logical(details))
  #
  as.character(x, details = details) %>% cat("\n", sep = "")
}

#' Create formatted message.
#'
#' Accepts a message object and formats it as a MIME document.
#'
#' @inheritParams print.envelope
#' @export
#'
#' @return A formatted message object.
as.character.envelope <- function(x, ..., details = TRUE) {
  message <- list(
    headers(x)
  )

  if (length(x$parts) > 1) {
    body <- multipart_mixed(children = x$parts)
  } else {
    body <- x$parts[[1]]
  }

  body <- encrypt_body(
    body,
    parties(x),
    encrypt = x$encrypt,
    sign = x$sign,
    public_key = x$public_key
  )

  if (details) {
    message <- c(message, as.character(body))
  }

  do.call(paste0, c(list(message), collapse = "\r\n"))
}

#' Append children to message
#'
#' @param x Message object
#' @param child A child to be appended
append.envelope <- function(x, child) {
  if(is.null(x$parts)) {
    log_debug("Adding first child.")
    x$parts <- list(child)
  } else {
    log_debug("Adding subsequent child.")
    x$parts <- c(x$parts, list(child))
  }

  x
}

skip_on_ci()
skip_on_cran()
skip_if_not(
  require(Microsoft365R, quietly=TRUE),
  "{Microsoft365R} tests skipped (package not available)."
)

# To run these tests you'll need to first authenticate. This is done by running
# the following command in an interactive session.
#
# It might also help to login to a Microsoft account (https://login.live.com/).

outlook <- get_personal_outlook()

from_addr <- "anne@example.com"
to_addr <- "bob@example.com"
cc_addr <- "jane@example.com"
bcc_addr <- "rex@example.com"

msg <- envelope(
  to = to_addr,
  cc = cc_addr,
  bcc = bcc_addr,
  subject = SUBJECT,
  html = HTMLCONTENT
)
msg_outlook <- outlook$create_email(msg)

test_that("body is correct", {
  expect_identical(msg_outlook$properties$body$contentType, "html")
  expect_true(grepl(HTMLCONTENT, msg_outlook$properties$body$content))
})

test_that("subject is correct", {
  expect_identical(msg_outlook$properties$subject, SUBJECT)
})

test_that("parties are correct", {
  expect_identical(msg_outlook$properties$toRecipients[[1]]$emailAddress$address, as.character(to(msg)))
  expect_identical(msg_outlook$properties$ccRecipients[[1]]$emailAddress$address, as.character(cc(msg)))
  expect_identical(msg_outlook$properties$bccRecipients[[1]]$emailAddress$address, as.character(bcc(msg)))
})

test_that("attachment: set", {
  msg <- envelope() %>% attachment(TXTPATH)

  expect_match(as.character(msg), TXTCONTENT_ENCODED)
})

test_that("attachment: specify CID", {
  cid <- "histogram"

  msg <- envelope() %>% attachment(JPGPATH, cid = cid)

  expect_true(
    grepl(
      mime_base64encode(JPGPATH),
      as.character(msg),
      fixed = TRUE
    )
  )
  expect_equal(msg$parts[[1]]$cid, cid)
})

test_that("attachment: number of files", {
  msg <- envelope()

  expect_error(msg %>% attachment())
  expect_error(msg %>% attachment(c(TXTPATH, JPGPATH)))
})

test_that("subject: set/get", {
  msg <- envelope() %>% subject("Test message")
  expect_equal(subject(msg), "Test message")
})

test_that("interpolate", {
  name <- "Alice"
  variables <- list(name = name)

  expect_equal(
    envelope() %>%
      subject("Hello {{name}}!") %>%
      subject(),
    "Hello Alice!"
  )
  expect_equal(
    envelope() %>%
      subject("Hello {{name}}!", .envir = variables) %>%
      subject(),
    "Hello Alice!"
  )
})

test_that("read receipt", {
  expect_error(envelope() %>% request_receipt_read())

  msg <- envelope() %>%
    from("olivia@google.com") %>%
    request_receipt_read()

  expect_match(headers(msg), "Return-Receipt-To: +olivia@google.com")
  expect_match(headers(msg), "Disposition-Notification-To: +olivia@google.com")
  expect_match(headers(msg), "X-Confirm-Reading-To: +olivia@google.com")
})

sanitise <- function(email, strip_comments = TRUE) {
  email %>%
    str_trim() %>%
    str_replace("[:blank:]+@[:blank:]+", "@") %>% {
      if (strip_comments) {
        str_remove_all(., "\\([^)]*\\)")
      } else {
        . # nocov
      }
    }
}

#' Tests whether an email address is syntactically correct
#'
#' Checks whether an email address conforms to the [syntax rules](https://en.wikipedia.org/wiki/Email_address#Syntax).
#'
#' An email address may take either of the following forms:
#'
#' - `local@domain` or
#' - `Display Name <local@domain>`.
#'
#' @param addr An email address.
#' @param error Whether to create an error if not compliant.
#'
#' @return A Boolean.
#' @export
#'
#' @examples
#' compliant("alice@example.com")
#' compliant("alice?example.com")
compliant <- function(addr, error = FALSE) {
  addr <- as.address(addr)

  email <- addr %>% raw()
  local <- addr %>% local()
  domain <- addr %>% domain()

  # Test on whole email address.
  #
  email <- grepl("[a-z0-9._%+-]+@[a-z0-9.-]+\\.[a-z]{2,}", email, ignore.case=TRUE)

  # Test on local part.
  #
  local <- TRUE &
    # No consecutive ".".
    !grepl("[.]{2,}.*", local) &
    # Only alphanumeric at beginning and end.
    !grepl("^[^[:alnum:]]", local) &
    !grepl("[^[:alnum:]]$", local) &
    # Not longer than 64 characters.
    !grepl(".{65,}", local) &
    ifelse(
      grepl('".*"', local),
      # Quoted.
      TRUE,
      # Unquoted.
      !grepl('[[:blank:]]+.*', local)             # No spaces in local.
    )

  # Test on domain.
  #
  domain <- TRUE &
    # No funky symbols.
    !grepl("[_]*", domain) &
    # Not longer than 255 characters.
    !grepl(".{256,}", domain)

  okay <- email & local
  if (error && !okay) {
    stop(paste0("Address '", addr, "' invalid."), call. = FALSE)
  } else {
    okay
  }
}

#' Helper function for creating address objects
#'
#' @inheritParams address
#'
#' @return An \code{address} object, representing an email address.
new_address <- function(
  email = character(),
  display = character(),
  local = character(),
  domain = character(),
  normalise = TRUE
) {
  vec_assert(email, ptype = character())
  vec_assert(display, ptype = character())
  vec_assert(local, ptype = character())
  vec_assert(domain, ptype = character())

  email <- ifelse(!is.na(email), email, paste0(local, "@", domain))

  if (normalise) {
    email <- sanitise(email)
    display <- str_squish(display)
  }

  new_rcrd(list(email = email, display = display), class = "vctrs_address")
}

#' Email Address
#'
#' Create an \code{address} object which represents an email address.
#'
#' Implemented as an \href{https://cran.r-project.org/package=vctrs/vignettes/s3-vector.html}{S3 vector class}.
#'
#' @param email Email address.
#' @param display Display name.
#' @param local Local part of email address.
#' @param domain Domain part of email address.
#' @param normalise Whether to try to normalise address to RFC-5321 requirements.
#'
#' @return An \code{address} object, representing an email address.
#' @export
#'
#' @examples
#' address("gerry@gmail.com")
#' address("gerry@gmail.com", "Gerald")
#' address(
#'   c("gerry@gmail.com", "alice@yahoo.com", "jim@aol.com"),
#'   c("Gerald", "Alice", NA)
#' )
address <- function(
  email = NA,
  display = NA,
  local = NA,
  domain = NA,
  normalise = TRUE
) {
  if (any(is.na(email) & is.na(local) & is.na(domain))) {
    stop("Either email or local and domain must be specified.", call. = FALSE)
  }
  if (any(!is.na(email) & (!is.na(local) | !is.na(domain)))) {
    stop("Cannot specify both email and local/domain.", call. = FALSE)
  }
  if (any(is.na(email) & is.na(local) & !is.na(domain))) {
    stop("Must specify local with domain.", call. = FALSE)
  }
  if (any(is.na(email) & !is.na(local) & is.na(domain))) {
    stop("Must specify domain with local.", call. = FALSE)
  }

  # Cast email and display to character and recycle to same length.
  #
  # This operator could be done more cleanly using %<-% from {zeallot} but
  # not doing that for the moment to avoid another dependency.
  #
  args <- do.call(
    vec_recycle_common,
    vec_cast_common(email, display, local, domain, .to = character())
  ) %>%
    setNames(c("email", "display", "local", "domain")) %>%
    set("normalise", normalise)

  do.call(new_address, args)
}

#' Encode email addresses in a common format
#'
#' @param x A vector of \code{address} objects.
#' @param ... Further arguments passed to or from other methods.
#'
#' @return A character vector.
#' @export
format.vctrs_address <- function(x, ...) {
  email <- field(x, "email")
  display <- field(x, "display")

  fmt <- ifelse(is.na(display), email, glue("{display} <{email}>"))
  fmt[is.na(email)] <- NA

  fmt
}


#' Display full type of vector
#'
#' Need to import the vec_ptype_full() generic.
#'
#' @noRd
#' @export
vec_ptype_full.vctrs_address <- function(x) {
  "address"
}

#' Display abbreviated type of vector
#'
#' Need to import the vec_ptype_abbr() generic.
#'
#' @noRd
#' @export
vec_ptype_abbr.vctrs_address <- function(x) {
  "addr"
}

#' Convert address object to character
#'
#' @param x  A vector of \code{address} objects.
#' @param ... Further arguments passed to or from other methods.
#'
#' @return A character vector.
#' @export
as.character.vctrs_address <- function(x, ...) {
  format(x, ...)
}

#' Compare address objects
#'
#' @noRd
#'
#' @param e1 LHS operand.
#' @param e2 RHS operand.
#'
#' @return A Boolean, \code{TRUE} if the \code{e1} address is the same as the
#'   \code{e2} address (ignores the display name).
#' @export
Ops.vctrs_address <- function(e1, e2)
{
  if (!("address" %in% class(e1))) e1 <- as.address(e1)
  if (!("address" %in% class(e2))) e2 <- as.address(e2)

  get(.Generic)(raw(e1), raw(e2))
}

#' Create an address object
#'
#' @param addr An email address.
#'
#' @return An \code{address} object.
#' @export
#'
#' @examples
#' as.address("gerry@gmail.com")
#' as.address("Gerald <gerry@gmail.com>")
#' as.address(c("Gerald <gerry@gmail.com>", "alice@yahoo.com", "jim@aol.com"))
#' as.address("Gerald <gerry@gmail.com>, alice@yahoo.com, jim@aol.com")
#' as.address(c("Gerald <gerry@gmail.com>", "alice@yahoo.com, jim@aol.com"))
as.address <- function(addr) {
  if ("vctrs_address" %in% class(addr)) {
    addr
  } else {
    # Check if multiple comma-separated addresses.
    #
    addr <- str_split(addr, ", *") %>% unlist()
    #
    display <- ifelse(
      str_detect(addr, "[<>]"),
      str_extract(addr, ".*<") %>% str_remove("<"),
      NA
    )
    email <- ifelse(
      str_detect(addr, "[<>]"),
      str_extract(addr, "<.*>") %>% str_remove_all("[<>]"),
      addr
    )

    address(email, display)
  }
}

#' Print an address object
#'
#' @param x An \code{address} object.
#' @param ... Further arguments passed to or from other methods.
#'
#' @export
#'
#' @examples
#' gerry <- as.address("gerry@gmail.com")
#' print(gerry)
print.vctrs_address <- function(x, ...) {
  print(format(x))
}

#' Extract raw email address
#'
#' Strips the display name off an email address (if present).
#'
#' @param addr An \code{address} object.
#'
#' @return A raw email address.
#' @export
#'
#' @examples
#' gerry <- as.address("Gerald <gerry@gmail.com>")
#' raw(gerry)
raw <- function(addr) {
  field(addr, "email")
}

#' Extract display name
#'
#' Extracts the display name from an email address.
#'
#' @param addr An \code{address} object.
#'
#' @return The display name or \code{NA}.
#' @export
#'
#' @examples
#' gerry <- as.address("Gerald <gerry@gmail.com>")
#' display(gerry)
display <- function(addr) {
  field(addr, "display")
}

#' Extract local part of email address
#'
#' @param addr An \code{address} object.
#'
#' @return A character vector.
#' @export
#'
#' @examples
#' local("alice@example.com")
local <- function(addr) {
  addr <- as.address(addr)
  raw(addr) %>%
    str_remove("@.*$")
}

#' Extract domain of email address
#'
#' @param addr An \code{address} object.
#'
#' @return A character vector.
#' @export
#'
#' @examples
#' domain("alice@example.com")
domain <- function(addr) {
  addr <- as.address(addr)
  raw(addr) %>%
    str_remove("^.*@")
}

test_that("returns local part of email address", {
  expect_equal(local("alice@example.com"), "alice")
})

test_that("returns domain of email address", {
  expect_equal(domain("alice@example.com"), "example.com")
})

test_that("create address", {
  expect_equal(
    address(
      c("gerry@gmail.com", "alice@yahoo.com", "jim@aol.com"),
      c("Gerald", "Alice", NA)
    ),
    c(
      address("gerry@gmail.com", "Gerald"),
      address("alice@yahoo.com", "Alice"),
      address("jim@aol.com")
    )
  )
})

test_that("create address from local and domain", {
  expect_equal(
    address(local = c("alice", "erin"), domain = "yahoo.com"),
    address(c("alice@yahoo.com", "erin@yahoo.com"))
  )
})

test_that("mandatory arguments", {
  expect_error(address())
  expect_error(address(NA, "Bob"))
  expect_error(address(local = "alice"))
  expect_error(address(domain = "yahoo.com"))
  expect_error(address("alice@yahoo.com", local = "alice"))
  expect_error(address("alice@yahoo.com", domain = "yahoo.com"))
})

test_that("convert to character", {
  expect_equal(as.character(address("gerry@gmail.com")), "gerry@gmail.com")
  expect_equal(as.character( address("gerry@gmail.com", "Gerald")), "Gerald <gerry@gmail.com>")
})

test_that("normalise", {
  expect_equal(
    as.character(address("    gerry@gmail.com    ", normalise = FALSE)),
    "    gerry@gmail.com    "
  )
  expect_equal(as.character(address("    gerry  @ gmail.com    ")), "gerry@gmail.com")
  expect_equal(
    as.character(address("    gerry  @ gmail.com    ", "      Gerald    ")),
    "Gerald <gerry@gmail.com>"
  )
})

test_that("parse address", {
  expect_equal(as.address("     Gerald    <   gerry@gmail.com  >   "), address("gerry@gmail.com", "Gerald"))
})

test_that("normalise", {
  expect_equal(as.address("     Gerald    <   gerry@gmail.com    >"), address("gerry@gmail.com", "Gerald"))
})

test_that("full type of vector", {
  expect_equal(vec_ptype_full(address("alice@yahoo.com", "Alice")), "address")
})

test_that("abbreviated type of vector", {
  expect_equal(vec_ptype_abbr(address("alice@yahoo.com", "Alice")), "addr")
})

test_that("print address", {
  expect_output(print(address("alice@yahoo.com", "Alice")), "Alice <alice@yahoo.com>")
})

test_that("address operators", {
  expect_true(address("alice@yahoo.com", "Alice") == address("alice@yahoo.com", "Alice"))
  expect_true(address("alice@yahoo.com", "Alice") == "Alice <alice@yahoo.com>")
  expect_true(address("alice@yahoo.com", "Alice") == address("alice@yahoo.com", "Gerald"))
  expect_true(address("alice@yahoo.com", "Alice") != address("bob@gmail.com", "Bob"))
  expect_true(address("alice@yahoo.com", "Alice") != address("gerry@gmail.com", "Alice"))
  #
  # Undefined operation.
  #
  expect_error(address("alice@yahoo.com", "Alice") / address("gerry@gmail.com", "Alice"))
})

test_that("split address list", {
  addr_list <- address(
    c("gerry@gmail.com", "alice@yahoo.com", "jim@aol.com"),
    c("Gerald", NA, NA)
  )

  expect_equal(
    as.address(c("Gerald <gerry@gmail.com>", "alice@yahoo.com", "jim@aol.com")),
    addr_list
  )
  expect_equal(
    as.address("Gerald <gerry@gmail.com>, alice@yahoo.com, jim@aol.com"),
    addr_list
  )
  expect_equal(
    as.address(c("Gerald <gerry@gmail.com>", "alice@yahoo.com, jim@aol.com")),
    addr_list
  )
})

test_that("returns display name", {
  expect_equal(display(as.address("Gerald   <gerry@gmail.com>")), "Gerald")
})

test_that("returns NA when no display name present", {
  expect_equal(display(as.address("gerry@gmail.com")), NA_character_)
})

test_that("compliant", {
  expect_true(compliant("alice@example.com"))
  expect_true(compliant("al.ice@example.com"))
})

test_that("not compliant", {
  expect_false(compliant("alice?example.com"))
  # More than one consecutive ".".
  expect_false(compliant("al..ice@example.com"))
  # Start or end with ".".
  expect_false(compliant(".alice@example.com"))
  expect_false(compliant("alice.@example.com"))
  expect_false(compliant("alice.@example.com"))
  expect_false(compliant("XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX@gmail.com"))
  expect_false(compliant("al ice@example.com"))
  # Missing '@'.
  expect_false(compliant("alice.yahoo.com"))
})

test_that("not compliant raises error", {
  expect_error(compliant("alice?example.com", error = TRUE))
})

#' @import curl
#' @import digest
#' @import dplyr
#' @import htmltools
#' @import logger
#' @import purrr
#' @import stringr
#' @import tidyr
#' @import xml2
#' @importFrom base64enc base64encode
#' @importFrom commonmark markdown_html
#' @importFrom glue glue
#' @importFrom httr http_date
#' @importFrom mime guess_type
#' @importFrom rmarkdown render html_document
#' @importFrom stats setNames
#' @importFrom stringi stri_replace_all_fixed stri_replace_all_regex
#' @importFrom tools file_ext
#' @importFrom urltools url_decode
#' @importFrom utils packageVersion
#' @importFrom vctrs new_rcrd vec_recycle_common vec_cast_common vec_assert field
#' @importFrom vctrs vec_ptype_abbr vec_ptype_full
#' @importFrom xfun read_utf8
NULL

globalVariables(
  c(
    ".",
    "e1",
    "e2",
    "fingerprint",
    "msg",
    "runif",
    "detect_language"
  )
)

LEVELS_ENCODING <- c("7bit", "quoted-printable", "base64")
LEVELS_PRIORITY <- c("non-urgent", "normal", "urgent")
LEVELS_IMPORTANCE <- c("low", "normal", "high")
LEVELS_MICALG <- c("pgp-sha256", "pgp-md5", "pgp-sha1", "pgp-ripemd160",
                   "pgp-md2", "pgp-tiger192", "pgp-haval-5-160")

CRLF <- "\r\n"

#' Add attachments to a message object
#'
#' @param msg A message object.
#' @param path Path to file.
#' @param name Name to be used for attachment (defaults to base name of \code{path}).
#' @param type MIME type or \cite{NA}, which will result in a guess based on file extension.
#' @param cid Content-ID or \code{NA}.
#' @param disposition How is attachment to be presented (\code{"inline"} or \code{"attachment"})?
#' @return A message object.
#' @export
#' @examples
#' path_mtcars  <- tempfile(fileext = ".csv")
#' path_scatter <- tempfile(fileext = ".png")
#' path_cats    <- system.file("cats.jpg", package = "emayili")
#'
#' write.csv(mtcars, path_mtcars)
#'
#' png(path_scatter)
#' plot(1:10)
#' dev.off()
#'
#' msg <- envelope() %>%
#'   attachment(path_mtcars) %>%
#'   # This attachment will have file name "cats.jpg".
#'   attachment(path_cats, name = "cats.jpg", type = "image/jpeg") %>%
#'   attachment(path_scatter, cid = "scatter")
#'
#' file.remove(path_scatter, path_mtcars)
attachment <- function(msg, path, name = NA, type = NA, cid = NA, disposition = "attachment") {
  if (length(path) != 1)
    stop("Must be precisely one attachment.", call. = F)

  body <- other(path, name, type, cid, disposition)

  msg <- append(msg, body)

  if (get_option_invisible()) invisible(msg) else msg # nocov
}

library(dplyr)

# spelling::spell_check_package()

devtools::check(cran = TRUE)

# Incoming feasibility checks for CRAN.
#
devtools::check(
  manual = TRUE,
  remote = TRUE,
  incoming = TRUE
)

# Check it on Windows.
#
devtools::check_win_devel()

rhub::check_for_cran()

# Check on macOS.
#
rhub::check_for_cran(
  platforms = rhub::platforms() %>%
    filter(categories == "macOS") %>%
    pull(name),
  env_vars = c(
    `_R_CHECK_FORCE_SUGGESTS_` = "true",
    `_R_CHECK_CRAN_INCOMING_USE_ASPELL_` = "false"
  )
)

# # Try this one instead?
# #
# rhub::check(platform = c("macos-highsierra-release"))
#
# rhub::check_for_cran(
#   platforms = "macos-highsierra-release-cran",
#   env_vars = c(
#     `_R_CHECK_FORCE_SUGGESTS_` = "true",
#     `_R_CHECK_CRAN_INCOMING_USE_ASPELL_` = "false"
#   )
# )

REGEX_BARE_LINEFEED = "(?<!\r)\n"

#' Pipe operator
#'
#' See \code{magrittr::\link[magrittr:pipe]{\%>\%}} for details.
#'
#' @name %>%
#' @rdname pipe
#' @keywords internal
#' @export
#' @importFrom magrittr %>%
#' @usage lhs \%>\% rhs
#' @param lhs A value or the magrittr placeholder.
#' @param rhs A function call using the magrittr semantics.
#' @return The result of calling `rhs(lhs)`.
NULL

# For adding elements to a list using %>%.
#
set <- .Primitive("[[<-")

#' Compare vectors
#'
#' Returns \code{TRUE} wherever elements are the same (including \code{NA}),
#' and \code{FALSE} everywhere else.
#'
#' @param lhs LHS of operation.
#' @param rhs RHS of operation.
#'
#' @return A Boolean value.
compare <- function(lhs, rhs) {
  same <- (lhs == rhs) | (is.na(lhs) & is.na(rhs))
  same[is.na(same)] <- FALSE
  same
}

#' Read entire text file into character vector
#'
#' @noRd
#'
#' @inheritParams stringr::str_c
#' @param path Relative or absolute file path. This can also be a vector of
#'             paths, in which case their content is concatenated.
#'
#' @return A character vector
read_text <- function(path, encoding = "UTF-8", collapse = "\n") {
  map(path, function(p) {
    if (!file.exists(p)) stop("Unable to find file: ", p, ".", call. = FALSE)
    readLines(p, encoding = encoding, warn = FALSE)
  }) %>%
    unlist()%>%
    str_c(collapse = collapse)
}

#' Read entire binary file into character vector
#'
#' @noRd
#'
#' @param path Relative or absolute file path
#'
#' @return A character vector
read_bin <- function(path) {
  readBin(path, "raw",  file.info(path)$size)
}

#' Normalise file path
#'
#' @noRd
#'
#' @param path Relative or absolute file path
#'
#' @return An absolute file path (if the file exists) or \code{NA}.
normalise_filepath <- function(path) {
  possibly(normalizePath, NA_character_)(path, mustWork = TRUE)
}

#' Check if character vector is a file name or file path
#'
#' @noRd
#'
#' @param path A character vector (which might also be a file path)
#'
#' @return If it is a file path, then return \code{TRUE}, otherwise return \code{FALSE}.
is_filepath <- function(path) {
  !is.na(normalise_filepath(path))
}

hexkey <- function(object = runif(1), algorithm="crc32") {
  digest(object, algorithm)
}

#' Drape line feeds
#'
#' Replace empty line-feeds, "\n", with carriage-return and line-feed, "\r\n".
#'
#' @noRd
drape_linefeed <- function(txt) {
  str_replace_all(txt, REGEX_BARE_LINEFEED, "\r\n")
}

#' Remove comments from CSS
#'
#' Will handle comments with the following form:
#'
#' - /* ... */
#' - /*! ... */
#'
#' @noRd
css_remove_comment <- function(css) {
  str_replace_all(css, "/\\*!?(\\*(?!/)|[^\\*])*\\*/", "")
}

#' Remove gratuitous whitespace from HTML
#'
#' @param html HTML content as character vector.
#'
#' @noRd
html_squish <- function(html) {
  html %>%
    # Remove duplicate \n (when surrounded by whitespace and tags).
    #
    # <div>\n\n\n<p>foo \n\n bar</p>\n\n</div> -> <div>\n<p>foo \n\n bar</p>\n</div>
    #
    str_replace_all("(?<=>) *(\n)+ *(?=<)", "\n") %>%
    # Remove just whitespace between tags.
    #
    # <div>  <p>foo    bar</p>  </div>         -> <div><p>foo    bar</p></div>
    #
    str_replace_all("(^|(?<=>)) +($|(?=<))", "")
}

mime_base64encode <- function(raw, linewidth = 76L) {
  if (!is.raw(raw)) {
    if (tryCatch(file.exists(raw), error = function(e) FALSE)) {
      log_debug("Assuming that input is a file.")
    } else {
      log_debug("Assuming that input is not a file.")
      if (is.character(raw)) {
        raw <- charToRaw(raw)
      } else {
        raw <- as.raw(raw)
      }
    }
  }

  base64encode(
    raw,
    linewidth,
    "\r\n"
  )
}

#' Generate MD5 checksum for Content-MD5 header field
#'
#' The MD5 checksum is a 128 bit digest. This corresponds to 16 bytes (octets)
#' of binary data. These 16 bytes are then Base64 encoded.
#'
#' @noRd
#'
#' @param object An arbitrary R object.
#'
#' @return Base64 encoded MD5 checksum.
#'
#' @examples
#' # Result should be "XrY7u+Ae7tCTyyK7j1rNww==".
#' md5("hello world")
md5 <- function(object) {
  digest(object, algo = "md5", serialize = FALSE, raw = TRUE) %>%
    mime_base64encode()
}

parse_datetime <- function(datetime, tz) {
  as.POSIXct(datetime, tz)
}

#' Format date
#'
#' Format like "Fri, 08 Oct 2021 22:06:39 -0700 (PDT)".
#'
#' @noRd
format_datetime <- function(datetime) {
  strftime(datetime, "%a, %d %b %Y %H:%M:%S %z (%Z)")
}

#' Enclose in angle brackets
#'
#' @noRd
wrap_angle_brackets <- function(x) {
  if (!grepl("^<", x)) x <- paste0("<", x)
  if (!grepl(">$", x)) x <- paste0(x, ">")
  x
}

#' Test if list is nested or flat
#'
#' @noRd
#' @param x A list.
#' @return A Boolean.
is.nested <- function(x) {
  stopifnot(is.list(x))
  any(sapply(x, function(x) any(class(x) == "list")))
}

smtp_url <- function(host, port, protocol = NA, helo = NA) {
  helo <- ifelse(is.na(helo), "", helo)

  # Check if host includes protocol.
  if (!grepl("^smtps?://", host)) {
    if (is.na(protocol)) {
      protocol <- ifelse(port == 465, "smtps", "smtp")
    } else {
      protocol <- tolower(protocol)
      if (!grepl("^smtps?$", protocol)) {
        stop("Invalid protocol: only SMTP and SMTPS are allowed.")
      }
    }
    protocol <- paste0(protocol, "://")
  } else {
    protocol= ""
  }

  sprintf("%s%s:%d/%s", protocol, host, port, helo)
}

stop <- function(..., call. = FALSE, domain = NULL) {
  txt <- glue::glue(...)
  base::stop(txt, call. = call., domain = domain)
}

test_that("drape line feeds", {
  expect_equal(drape_linefeed("foo\nbar"), "foo\r\nbar")
  expect_equal(drape_linefeed("foo\r\nbar"), "foo\r\nbar")
  expect_equal(drape_linefeed("foo\n\n\nbar"), "foo\r\n\r\n\r\nbar")
})

test_that("remove CSS comments", {
  expect_equal(css_remove_comment("/*! * Bootstrap v3.3.5 */"), "")
  expect_equal(css_remove_comment("/* * Bootstrap v3.3.5 */"), "")
  expect_equal(
    css_remove_comment("/* * Bootstrap v3.3.5 */ p {} /*! normalize.css */"),
    " p {} "
  )
})

test_that("enclose angle brackets", {
  expect_equal(wrap_angle_brackets("<foo"), "<foo>")
  expect_equal(wrap_angle_brackets("foo>"), "<foo>")
  expect_equal(wrap_angle_brackets("<foo>"), "<foo>")
  expect_equal(wrap_angle_brackets("foo"), "<foo>")
})

test_that("smtp server URL", {
  expect_equal(smtp_url("smtp.gmail.com", 465, protocol = NA), "smtps://smtp.gmail.com:465/")
  expect_equal(smtp_url("smtp.gmail.com", 587, protocol = NA), "smtp://smtp.gmail.com:587/")
  expect_equal(smtp_url("smtp.gmail.com", 465, protocol = "smtp"), "smtp://smtp.gmail.com:465/")
  expect_equal(smtp_url("smtp.gmail.com", 587, protocol = "smtps"), "smtps://smtp.gmail.com:587/")
  expect_equal(smtp_url("smtp://smtp.gmail.com", 465, protocol = "smtps"), "smtp://smtp.gmail.com:465/")
  expect_equal(smtp_url("smtps://smtp.gmail.com", 587, protocol = "smtp"), "smtps://smtp.gmail.com:587/")
  expect_error(emayili:::smtp_url("smtp.gmail.com", 443, protocol = "http"))
})

test_that("base64 encoding with non-file input", {
  expect_equal(emayili:::mime_base64encode("Hello!"), "SGVsbG8h")
  expect_equal(emayili:::mime_base64encode(42), "Kg==")
})

test_that("compare", {
  expect_false(all(compare(c(1, 2, 3, 4), c(1, 2, 3, NA))))
  expect_true(all(compare(c(1, 2, 3, NA), c(1, 2, 3, NA))))
})

# Headers for the MIME protocol.

content_type <- function(type, protocol, charset, boundary, format = NA, name = NA) {
  header(
    "Content-Type",
    c(
      type,
      if (!is.na(protocol)) glue('protocol="{protocol}"') else NULL,
      if (!is.na(charset)) glue('charset={charset}') else NULL,
      if (!is.na(boundary)) glue('boundary="{boundary}"') else NULL,
      if (!is.na(format)) glue('format={format}') else NULL,
      if (!is.na(name)) glue('name="{name}"') else NULL
    ),
    sep = "; "
  )
}

content_disposition <- function(disposition = NA, filename = NA) {
  if (is.na(disposition)) {
    NULL
  } else {
    if (!is.na(filename)) {
      disposition <- paste(disposition, glue('filename="{filename}"'), sep = "; ")
    }
    header("Content-Disposition", disposition)
  }
}

content_transfer_encoding <- function(encoding = NA) {
  if (is.na(encoding)) {
    NULL
  } else {
    header("Content-Transfer-Encoding", encoding)
  }
}

content_description <- function(description = NA) {
  if (is.na(description)) {
    NULL
  } else {
    header("Content-Description", description)
  }
}

x_attachment_id <- function(cid = NULL) {
  if (is.null(cid)) {
    NULL
  } else {
    header("X-Attachment-Id", cid)
  }
}

content_id <- function(cid = NULL) {
  if (is.null(cid)) {
    NULL
  } else {
    header("Content-ID", paste0("<", cid, ">"))
  }
}

content_md5 <- function(content) {
  header("Content-MD5", md5(content))
}

#' Set or query message expiry or reply-by time
#'
#' Functions to specify the time at which a message expires or by which a reply
#' is requested.
#'
#' Manipulate the \code{Expires} and \code{Reply-By} fields as specified in
#' \href{https://www.ietf.org/rfc/rfc2156.txt}{RFC 2156}.
#'
#' @name cutoff
#'
#' @param msg A message object.
#' @param datetime Date and time.
#' @param tz A character string specifying the time zone.
#' @return A message object.
NULL

#' @rdname cutoff
#' @export
#'
#' @examples
#' envelope() %>%
#'   expires("2030-01-01 13:25:00", "UTC")
expires <- function(msg, datetime = NULL, tz = "") {
  if (is.null(datetime)) {
    header_get(msg, "Expires")
  } else {
    datetime <- parse_datetime(datetime, tz)%>%
      format_datetime()

    msg <- header_set(msg, "Expires", datetime, append = FALSE)

    if (get_option_invisible()) invisible(msg) else msg # nocov
  }
}

#' @rdname cutoff
#' @export
#'
#' @examples
#' envelope() %>%
#'   replyby("2021-12-25 06:00:00", "GMT")
replyby <- function(msg, datetime = NULL, tz = "") {
  if (is.null(datetime)) {
    header_get(msg, "Reply-By")
  } else {
    datetime <- parse_datetime(datetime, tz)%>%
      format_datetime()

    msg <- header_set(msg, "Reply-By", datetime, append = FALSE)

    if (get_option_invisible()) invisible(msg) else msg # nocov
  }
}

header <- function(
  name,
  values,
  sep = NULL
) {
  structure(
    list(
      name = name,
      values = values,
      sep = sep
    ),
    class = "header"
  )
}

#' Create formatted header.
#'
#' Accepts a header object and formats it as a header field.
#'
#' @param x A header object.
#' @param width The width of the head name field.
#' @param ... Further arguments passed to or from other methods.
#' @export
#'
#' @return A formatted header field.
as.character.header <- function(x, width = 28, ...) {
  FORMAT <- glue("%-{width}s %s")
  INDENT <- strrep(" ", width + 1)

  header <- sprintf(
    FORMAT,
    paste0(x$name, ":"),
    paste(
      sapply(x$values, as.character),
      collapse = x$sep
    )
  )

  # Split header parameters across lines.
  if (!is.null(x$sep)) {
    header <- header %>%
      str_replace_all(
        paste0("(", str_trim(x$sep, side = "right"), ")"),
        paste0("\\1", CRLF, INDENT)
      )
  }

  header
}

print.header <- function(x, ... ) {
  print(as.character(x))
}

header_get <- function(msg, name) {
  msg$headers[[name]]$values
}

header_set <- function(msg, name, values, append = FALSE, sep = NULL) {
  # Get current header.
  header <- msg$headers[[name]]
  # Header has not previously been set.
  if (is.null(header)) {
    header <- header(name, c(), sep)
  } else {
    if (append) {
      values <- c(header$values, values)
    }
  }

  # Set current header values.
  header$values <- values

  msg$headers[[name]] <- header

  msg
}

test_that("print header", {
  expect_output(
    print(header("Header", "value")),
    "Header: +value"
  )
})

test_that("header append", {
  # Don't append.
  expect_equal(
    envelope() %>%
      header_set("Header", "first") %>%
      header_set("Header", "second") %>%
      header_get("Header"),
    "second"
  )
  # Do append.
  expect_equal(
    envelope() %>%
      header_set("Header", "first") %>%
      header_set("Header", "second", append = TRUE) %>%
      header_get("Header"),
    c("first", "second")
  )
})

#' Extract sender and recipient(s)
#'
#' @param msg A message object.
#'
#' @return A tibble.
#' @export
#'
#' @examples
#' email <- envelope() %>%
#'   from("Gerald <gerald@gmail.com>") %>%
#'   to(c("bob@gmail.com", "alice@yahoo.com")) %>%
#'   cc("Craig     < craig@gmail.com>") %>%
#'   bcc("  Erin   <erin@yahoo.co.uk    >")
#'
#' parties(email)
parties <- function(msg) {
  # Avoid "no visible binding for global variable" note.
  address <- NULL # nocov
  values <- NULL # nocov

  map_dfr(c("From", "To", "Cc", "Bcc"), function(type) {
    tibble(
      type,
      address = msg$headers[type]
    )
  }) %>%
    hoist(address, "values") %>%
    unnest(values) %>%
    select(-address) %>%
    rename(address = values) %>%
    mutate(
      display = display(address),
      raw = raw(address),
      local = local(address),
      domain = domain(address)
    )
}

ERROR_NOT_MIME_OBJECT <- "Child is not a MIME object."

# CONSTRUCTOR -----------------------------------------------------------------

is.mime <- function(x) {
  "MIME" %in% class(x)
}

#' Parameters for MIME functions
#'
#' These are parameters which occur commonly across functions for components of
#' a MIME document.
#'
#' @name mime-parameters
#'
#' @param content A string of message content.
#' @param disposition Should the content be displayed inline or as an
#'   attachment? Valid options are \code{"inline"} and \code{"attachment"}. If
#'   set to \code{NA} then will guess appropriate value.
#' @param charset What character set is used. Most often either \code{"UTF-8"}
#'   or \code{"ISO-8859-1"}.
#' @param encoding How content is transformed to ASCII. Options are
#'   \code{"7bit"}, \code{"quoted-printable"} and \code{"base64"}. Use \code{NA}
#'   or \code{NULL} for no (or "identity") encoding.
#' @param language Langauge of content. If \code{FALSE} then will not include
#'   language field. If \code{TRUE} then will attempt to auto-detect language.
#'   Otherwise will use the specified language.
#' @param description Description of content.
#' @param name Name used when downloading file.
#' @param filename Path to a file.
#' @param boundary Boundary string.
#' @param type The MIME type of the content.
#' @param children List of child MIME objects.
#' @param interpolate Whether or not to interpolate into input using \link[glue]{glue}.
#' @param .open The opening delimiter.
#' @param .close The closing delimiter.
#' @param .envir Environment used for \code{glue} interpolation. Defaults to \code{parent.frame()}.
NULL

#' Create a MIME object
#'
#' ```
#' MIME
#'  ├── multipart/mixed
#'  ├── multipart/related
#'  ├── text/plain
#'  ├── text/html
#'  └── other
#' ```
#'
#' @section MIME Multipart Types:
#'
#' There are a number of options for multipart messages:
#'
#' \itemize{
#'  \item{\code{multipart/mixed} — }{Used for sending content with multiple independent parts either inline or as attachments. Each part can have different \code{Content-Type}.}
#'  \item{\code{multipart/alternative} — }{Used when each part of the message is an "alternative" version of the same content. The order of the parts is important: preferred and/or more complex formats should be found towards the end.
#'
#'  \emph{Example:} A message with both plain text and HTML versions.}
#'  \item{\code{multipart/digest} — }{Used to send multiple plain text messages.}
#'  \item{\code{multipart/related} — }{Used when each part of the the message represents a component of the complete message.
#'
#'  \emph{Example:} A web page with images.}
#'  \item{\code{multipart/signed} — }{Used when a message has a digital signature attached.}
#'  \item{\code{multipart/encrypted} — }{Used for a message with encrypted content.}
#' }
#'
#' A nice illustration of how some of these relate can be found at \url{https://stackoverflow.com/a/40420648/633961}.
#'
#' @noRd
#' @return A MIME object.
MIME <- function(
  content = NULL,
  disposition = NA,
  protocol = NA,
  charset = NA,
  encoding = NA,
  language = NA,
  description = NA,
  name = NA,
  filename = NA,
  format = NA,
  boundary = hexkey(),
  type = NA,
  children = list()
) {
  # If just a single child, convert to list.
  if (!all(class(children) == c("list"))) children <- list(children)
  # Check that all children are MIME.
  for (child in children) {
    if (!is.mime(child)) stop(ERROR_NOT_MIME_OBJECT)
  }

  structure(
    list(
      content = content,
      disposition = disposition,
      protocol = protocol,
      charset = charset,
      encoding = encoding,
      language = language,
      description = description,
      name = name,
      filename = filename,
      format = format,
      boundary = boundary,
      children = children,
      type = type
    ),
    class = "MIME"
  )
}

multipart_related <- function(...) {
  structure(
    c(
      MIME(...),
      list()
    ),
    class = c("multipart_related", "MIME")
  )
}

multipart_mixed <- function(...) {
  structure(
    c(
      MIME(...),
      list()
    ),
    class = c("multipart_mixed", "MIME")
  )
}

#' Create \code{multipart/encrypted} MIME object
#'
#' @noRd
#'
#' @inheritParams MIME
multipart_encrypted <- function(
  content,
  ...
) {
  structure(
    c(
      MIME(
        "This is an OpenPGP/MIME encrypted message (RFC 4880 and 3156).",
        protocol = "application/pgp-encrypted",
        ...
      ),
      list()
    ),
    class = c("multipart_encrypted", "MIME")
  )
}

#' Create \code{multipart/signed} MIME object
#'
#' @noRd
#'
#' @inheritParams MIME
#' @param micalg Message Integrity Check ALGorithm. Valid options are:
#'   \code{"pgp-sha256"}, \code{"pgp-md5"}, \code{"pgp-sha1"},
#'   \code{"pgp-ripemd160"}, \code{"pgp-md2"}, \code{"pgp-tiger192"}, and
#'  \code{"pgp-haval-5-160"}.
multipart_signed <- function(
  micalg = "pgp-sha256",
  ...
) {
  if (!(micalg %in% LEVELS_MICALG)) stop('Invalid micalg: "{micalg}".')
  structure(
    c(
      MIME(
        "This is an OpenPGP/MIME signed message (RFC 4880 and 3156).",
        protocol = "application/pgp-signature",
        type = c("multipart/signed", 'micalg="{micalg}"'),
        ...
      ),
      list()
    ),
    class = c("multipart_signed", "MIME")
  )
}

application_pgp_encrypted <- function(
  content = "Version: 1",
  ...
) {
  structure(
    c(
      MIME(
        content,
        type = "application/pgp-encrypted",
        description = "PGP/MIME version identification",
        boundary = NA,
        ...
      ),
      list()
    ),
    class = c("application_pgp_encrypted", "MIME")
  )
}

application_pgp_signature <- function(
  content,
  ...
) {
  structure(
    c(
      MIME(
        content,
        type = "application/pgp-signature",
        description = "OpenPGP digital signature",
        name = "signature.asc",
        filename = "signature.asc",
        disposition = "attachment",
        boundary = NA,
        ...
      ),
      list()
    ),
    class = c("application_pgp_signature", "MIME")
  )
}

application_pgp_keys <- function(
  content,
  ...
) {
  structure(
    c(
      MIME(
        content,
        type = "application/pgp-keys",
        description = "OpenPGP public key",
        name = "keys.asc",
        filename = "keys.asc",
        disposition = "attachment",
        encoding = "quoted-printable",
        boundary = NA,
        ...
      ),
      list()
    ),
    class = c("application_pgp_keys", "MIME")
  )
}

application_octet_stream <- function(
  content,
  disposition = "inline",
  filename,
  ...
) {
  structure(
    c(
      MIME(
        content,
        disposition = disposition,
        type = "application/octet-stream",
        description = "OpenPGP encrypted message",
        name = filename,
        filename = filename,
        boundary = NA,
        ...
      ),
      list()
    ),
    class = c("application_octet_stream", "MIME")
  )
}

text_plain <- function(
  content,
  disposition = "inline",
  charset = "utf-8",
  encoding = "7bit",
  ...
) {
  structure(
    c(
      MIME(content, disposition, NA, charset, encoding, format = "flowed", boundary = NA, ...),
      list()
    ),
    class = c("text_plain", "MIME")
  )
}

#' Create \code{text/html} MIME object
#'
#' @noRd
#'
#' @inheritParams MIME
#' @param squish Whether to remove whitespace outside of tags.
#' @param ... Further arguments passed to or from other methods.
#'
#' @return A \code{text_html} object derived from \code{MIME}.
text_html <- function(
  content,
  disposition = "inline",
  charset = "utf-8",
  encoding = NA,
  squish = FALSE,
  css = NA,
  ...
) {
  # Clean up content.
  #
  if (squish) {
    content <- html_squish(content)
  }
  content <- read_html(content)

  if (length(css) && !all(is.na(css) | css == "")) {
    css <- css %>%
      unlist() %>%
      str_c(collapse = "\n") %>%
      css_remove_comment() %>%
      str_squish()

    # Add <head> (can be missing if rendering Plain Markdown).
    if (is.na(xml_find_first(content, "//head"))) {
      xml_add_sibling(
        xml_find_first(content, "//body"),
        "head",
        .where = "before"
      )
    }

    # Write consolidated CSS to single <style> tag.
    if (nchar(css)) {
      xml_add_child(
        xml_find_first(content, "//head"),
        "style",
        css,
        type = "text/css"
      )
    }
  }

  # Replace bare line-feeds.
  content <- drape_linefeed(as.character(content))

  structure(
    c(
      MIME(
        content,
        disposition,
        NA,
        charset,
        encoding,
        boundary = NA,
        ...
      ),
      list()
    ),
    class = c("text_html", "MIME")
  )
}

#' Other (not text or HTML) MIME content
#'
#' @noRd
#'
#' @inheritParams MIME
#'
#' @param cid An optional Content-Id.
#' @param ... Further arguments passed to or from other methods.
other <- function(
  filename,
  name = NA,
  type = NA,
  cid = NA,
  disposition = "attachment",
  encoding = "base64",
  ...
) {
  charset <- NA
  basename <- basename(filename)
  name <- ifelse(is.na(name), basename, name)

  if (!is.na(type)) {
    # Could use mime::mimemap to map from specific extensions to MIME types,
    # so that the following would give the same result:
    #
    # attachment(..., type = "pdf")
    # attachment(..., type = "application/pdf")
  } else {
    type <- guess_type(filename, empty = "application/octet-stream")
  }
  type <- glue('{type}; name="{name}"')

  if (is.na(disposition)) {
    disposition <- ifelse(
      grepl("text", type),
      # If it's text...
      "inline",
      # ... otherwise:
      "attachment"
    )
  }

  structure(
    c(
      MIME(read_bin(filename), disposition, NA, charset, encoding, boundary = NA, filename = name, type = type, ...),
      list(
        cid = ifelse(is.na(cid), hexkey(), cid)
      )
    ),
    class = c("attachment", "MIME")
  )
}

# APPEND & PREPEND ------------------------------------------------------------

#' Add children to MIME element
#'
#' @name add_children
#'
#' @param x MIME element
#' @param child Child MIME element
#' @return A MIME element.
#'
#' @noRd
NULL

#' @rdname add_children
#' @noRd
#'
append <- function(x, child) {
  UseMethod("append", x)
}
append.MIME <- function(x, child) {
  if (!is.mime(child)) stop(ERROR_NOT_MIME_OBJECT)
  x$children <- c(x$children, list(child))
  x
}

#' @rdname add_children
#' @noRd
#'
prepend <- function(x, child) {
  UseMethod("prepend", x)
}
prepend.MIME <- function(x, child) {
  if (!is.mime(child)) stop(ERROR_NOT_MIME_OBJECT)
  x$children <- c(list(child), x$children)
  x
}

# CHARACTER -------------------------------------------------------------------

#' MIME type of message part
#'
#' @noRd
#' @param part Message part.
#'
#' @return Character vector.
type <- function(x) {
  ifelse(!is.na(x$type), x$type, sub("_", "/", class(x)[1]))
}

#' Convert MIME object to character vector
#'
#' @param x MIME object
#' @param ... Further arguments passed to or from other methods.
as.character.MIME <- function(x, ...) {
  if (is.null(x$encoding)) x$encoding <- NA

  if (!is.na(x$encoding) && !(x$encoding %in% LEVELS_ENCODING)) {
    stop("Invalid encoding. Options are: ", paste(LEVELS_ENCODING, collapse = ", "), ".")
  }

  children <- sapply(x$children, function(child) {
    paste(paste0("--", x$boundary), as.character.MIME(child), sep = "\r\n")
  })
  #
  headers <- list(
    content_type(type(x), x$protocol, x$charset, x$boundary, x$format, x$name),
    content_description(x$description),
    content_disposition(x$disposition, x$filename),
    content_transfer_encoding(x$encoding),
    content_language(x$language, x$content),
    x_attachment_id(x$cid),
    content_id(x$cid)
  )
  #
  content <- x$content
  if (!is.na(x$encoding)) {
    if (x$encoding == "base64") {
      content <- mime_base64encode(content)
    } else if (x$encoding == "quoted-printable") {
      content <- qp_encode(content)
    }

    headers <- c(headers, list(content_md5(x$content)))
  }
  #
  body <- c(
    # Head.
    headers %>% compact() %>% sapply(as.character),
    "",
    # Content (if any).
    content,
    # Children (if any).
    if(length(children)) children else NULL,
    # Foot.
    if (!is.na(x$boundary)) glue('--{x$boundary}--') else NULL
  )

  paste(body, collapse = "\r\n")
}

# PRINT -----------------------------------------------------------------------

#' Print a MIME object
#'
#' @noRd
#'
#' @param x MIME object
#' @param ... Further arguments passed to or from other methods.
print.MIME <- function(x, ...) {
  cat(as.character(x))
}

# LENGTH ----------------------------------------------------------------------

#' Length of a MIME object
#'
#' The underlying object is a list, but we don't want the length of this
#' object to be the length of the list.
#'
#' This is especially important for when we have a message that only consists
#' of one MIME item. In that case we don't want it rendered as multipart/mixed.
#'
#' @noRd
#'
#' @param x A MIME object.
#'
#' @return The length of a MIME object (which is always one in units of MIME objects!).
length.MIME <- function(x) {
  1
}

test_that("children must be MIME", {
  expect_error(MIME(children = list(1)), ERROR_NOT_MIME_OBJECT)
  expect_error(append.MIME(MIME(), 1), ERROR_NOT_MIME_OBJECT)
  expect_error(prepend.MIME(MIME(), 1), ERROR_NOT_MIME_OBJECT)
})

test_that("create multipart/mixed", {
  expect_equal(class(multipart_mixed()), c("multipart_mixed", "MIME"))
})

test_that("convert single child to list", {
  expect_type(MIME(children = text_plain("Hello!"))$children, "list")
})

test_that("missing disposition", {
  mime_txt <- other(TXTPATH, disposition = NA)
  mime_jpg <- other(JPGPATH, disposition = NA)

  expect_match(mime_txt$type, "^text/plain")
  expect_match(mime_jpg$type, "^image/jpeg")

  expect_match(mime_txt$disposition, "^inline")
  expect_match(mime_jpg$disposition, "^attachment")
})

test_that("print", {
  mime_txt <- emayili:::other(TXTPATH, disposition = NA)

  expect_output(
    print.MIME(mime_txt),
    as.character.MIME(mime_txt) %>% str_replace_all("\r\n", "\n"),
    fixed = TRUE
  )
})

test_that("squish", {
  expect_match(
    text_html(
      "   <div>   <p>Hello!</p>   </div>   ",
      squish = TRUE
    )$content,
    "<div><p>Hello!</p></div>"
  )
})

test_that("header fields", {
  mime_txt <- other(TXTPATH, disposition = NA)

  expect_match(as.character.MIME(mime_txt), "Content-Type: +text/plain;[[:space:]]+name=\"[^.]+\\.txt\"\r\nContent-Disposition: +inline;[[:space:]]+filename=\"[^.]+\\.txt\"\r\nContent-Transfer-Encoding: +base64\r\nX-Attachment-Id: +.*\nContent-ID: +<[^>]+>\r\n")
})

test_that("valid encoding", {
  expect_error(MIME(encoding = "klingon") %>% as.character.MIME())
})

test_that("length", {
  expect_equal(length(MIME()), 1)
})

test_that("base64 encoding & MD5 checksum", {
  mime_txt <- emayili:::other(TXTPATH, disposition = NA)

  expect_match(
    as.character.MIME(mime_txt),
    TXTCONTENT_ENCODED
  )
  expect_match(
    as.character.MIME(mime_txt),
    "Content-MD5: +7r/PnFfETLz0CFCESunVvA==",
    fixed = FALSE
  )
})

test_that("order doesn't matter", {
  expect_error(
    envelope() %>% text("Hello!") %>% attachment(TXTPATH) %>% as.character(),
    NA
  )
  expect_error(
    envelope() %>% attachment(TXTPATH) %>% text("Hello!") %>% as.character(),
    NA
  )
})

test_that("MD5 checksum", {
  mime_jpg <- other(JPGPATH, disposition = NA)

  expect_match(
    as.character.MIME(mime_jpg),
    "Content-MD5: +0KTj0bnhRWCUK4N7LnvNmA=="
  )
})

test_that("order doesn't matter", {
  expect_error(
    envelope() %>% text("Hello!") %>% attachment(TXTPATH) %>% as.character(),
    NA
  )
  expect_error(
    envelope() %>% attachment(TXTPATH) %>% text("Hello!") %>% as.character(),
    NA
  )
})

test_that("invalid hash algorithm", {
  expect_error(multipart_signed(micalg = "pgp-sha0"))
})

# Headers for the mail protocol.

#' Add address fields to message
#'
#' @name addresses
#'
#' @param msg A message object.
#' @param addr Single address.
#' @param append Whether to append or replace addresses.
#' @return A message object.
NULL

#' @rdname addresses
#'
#' @param ... Addresses.
#'
#' @export
#' @examples
#' # Populating the To field.
#' msg <- envelope()
#' msg %>% to("bob@gmail.com, alice@yahoo.com")
#' msg %>% to("bob@gmail.com", "alice@yahoo.com")
#' msg %>% to(c("bob@gmail.com", "alice@yahoo.com"))
#'
to <- function(msg, ..., append = TRUE) {
  arguments <- c(...)
  if (is.null(arguments)) {
    header_get(msg, "To")
  } else {
    msg <- header_set(msg, "To", as.address(arguments), append = append, sep = ", ")
    if (get_option_invisible()) invisible(msg) else msg # nocov
  }
}

#' @rdname addresses
#'
#' @export
#' @examples
#' # Populating the Cc field.
#' msg <- envelope()
#' msg %>% cc("bob@gmail.com, alice@yahoo.com")
#' msg %>% cc("bob@gmail.com", "alice@yahoo.com")
#' msg %>% cc(c("bob@gmail.com", "alice@yahoo.com"))
#'
cc <- function(msg, ..., append = TRUE) {
  arguments <- c(...)
  if (is.null(arguments)) {
    header_get(msg, "Cc")
  } else {
    msg <- header_set(msg, "Cc", as.address(arguments), append = append, sep = ", ")
    if (get_option_invisible()) invisible(msg) else msg # nocov
  }
}

#' @rdname addresses
#'
#' @export
#' @examples
#' # Populating the Bcc field.
#' msg <- envelope()
#' msg %>% bcc("bob@gmail.com, alice@yahoo.com")
#' msg %>% bcc("bob@gmail.com", "alice@yahoo.com")
#' msg %>% bcc(c("bob@gmail.com", "alice@yahoo.com"))
#'
bcc <- function(msg, ..., append = TRUE) {
  arguments <- c(...)
  if (is.null(arguments)) {
    header_get(msg, "Bcc")
  } else {
    msg <- header_set(msg, "Bcc", as.address(arguments), append = append, sep = ", ")
    if (get_option_invisible()) invisible(msg) else msg # nocov
  }
}

#' @rdname addresses
#'
#' @export
#' @examples
#' msg <- envelope()
#'
#' # Populating the From field.
#' msg %>% from("craig@gmail.com")
#'
from <- function(msg, addr = NULL) {
  if (is.null(addr)) {
    header_get(msg, "From")
  } else {
    addr <- as.address(addr)
    if (length(addr) > 1) stop("Only one sender address allowed.")
    msg <- header_set(msg, "From", addr, append = FALSE)
    if (get_option_invisible()) invisible(msg) else msg # nocov
  }
}

#' @rdname addresses
#'
#' @export
#' @examples
#' # Populating the Reply-To field.
#' msg <- envelope()
#' msg %>% reply("gerry@gmail.com")
#'
reply <- function(msg, addr = NULL) {
  if (is.null(addr)) {
    header_get(msg, "Reply-To")
  } else {
    msg <- header_set(msg, "Reply-To", as.address(addr), append = FALSE)
    if (get_option_invisible()) invisible(msg) else msg # nocov
  }
}

#' @rdname addresses
#'
#' @export
#' @examples
#' # Populating the Return-Path field.
#' msg <- envelope()
#' msg %>% return_path("bounced-mail@devnull.org")
#'
return_path <- function(msg, addr = NULL) {
  if (is.null(addr)) {
    header_get(msg, "Return-Path")
  } else {
    msg <- header_set(msg, "Return-Path", as.address(addr), append = FALSE)
    if (get_option_invisible()) invisible(msg) else msg # nocov
  }
}

#' @rdname addresses
#'
#' @export
#' @examples
#' # Populating the Sender field.
#' msg <- envelope()
#' msg %>% sender("on_behalf_of@gmail.com")
sender <- function(msg, addr = NULL) {
  if (is.null(addr)) {
    header_get(msg, "Sender")
  } else {
    msg <- header_set(msg, "Sender", as.address(addr), append = FALSE)
    if (get_option_invisible()) invisible(msg) else msg # nocov
  }
}

#' Add or query subject of message.
#'
#' @inheritParams text
#' @param msg A message object.
#' @param subject A subject for the message.
#'
#' @return A message object or the subject of the message object (if \code{subject} is \code{NULL}).
#' @seealso \code{\link{to}}, \code{\link{from}}, \code{\link{cc}}, \code{\link{bcc}} and \code{\link{reply}}
#' @export
#' @examples
#' # Create a message and set the subject
#' msg <- envelope() %>% subject("Updated report")
#'
#' # Retrieve the subject for a message
#' subject(msg)
subject <- function(
  msg,
  subject = NULL,
  interpolate = TRUE,
  .open = "{{",
  .close = "}}",
  .envir = NULL
) {
  if (is.null(subject)) {
    header_get(msg, "Subject")
  } else {
    if (is.null(.envir)) .envir = parent.frame()
    else .envir = list2env(.envir)

    if (interpolate) subject <- glue(subject, .open = .open, .close = .close, .envir = .envir)

    msg <- header_set(msg, "Subject", subject, append = FALSE)
    if (get_option_invisible()) invisible(msg) else msg # nocov
  }
}

#' Add In-Reply-To and References header fields
#'
#' @name response
#'
#' @inheritParams addresses
#' @param msgid A message ID. This would be the contents of the \code{Message-ID}
#'   field from another message.
#' @param subject_prefix Prefix to add to subject. If specified will be prepended
#'   onto the \code{Subject} field. Set to `NULL` if not required.
#' @return A message object.
NULL

#' @rdname response
#'
#' @export
#' @examples
#' envelope() %>% inreplyto("<6163c08e.1c69fb81.65b78.183c@mx.google.com>")
#' # Now for German.
#' envelope() %>%
#'   inreplyto("6163c08e.1c69fb81.65b78.183c@mx.google.com", "AW: ")
inreplyto <- function(msg, msgid, subject_prefix = "Re: ") {
  msg <- msg %>%
    header_set("In-Reply-To", wrap_angle_brackets(msgid), append = FALSE) %>%
    subject(paste0(subject_prefix, subject(msg)))
  if (get_option_invisible()) invisible(msg) else msg # nocov
}

#' @rdname response
#'
#' @export
#' @examples
#' # And also for Danish, Norwegian and Swedish (but not Finnish!).
#' envelope() %>%
#'   references("6163c08e.1c69fb81.65b78.183c@mx.google.com", "SV: ")
references <- function(msg, msgid, subject_prefix = "Re: ") {
  msg <- msg %>%
    header_set("References", wrap_angle_brackets(msgid), append = FALSE) %>%
    subject(paste0(subject_prefix, subject(msg)))
  if (get_option_invisible()) invisible(msg) else msg # nocov
}

#' Add or query comments of message.
#'
#' @param msg A message object.
#' @param comments Comments for the message.
#'
#' @return A message object or the comments of the message object (if \code{comments} is \code{NULL}).
#' @seealso \code{\link{subject}}
#' @export
#' @examples
#' # Create a message and set the comments.
#' msg <- envelope() %>% comments("This is a comment")
#'
#' # Retrieve the comments for a message.
#' comments(msg)
comments <- function(msg, comments = NULL) {
  if (is.null(comments)) {
    header_get(msg, "Comments")
  } else {
    msg <- header_set(msg, "Comments", comments, append = FALSE)
    if (get_option_invisible()) invisible(msg) else msg # nocov
  }
}

#' Add or query keywords of message.
#'
#' @param msg A message object.
#' @param ... Keywords.
#' @param append Whether to append or replace keywords.
#'
#' @return A message object or the comments of the message object (if \code{comments} is \code{NULL}).
#' @seealso \code{\link{to}}, \code{\link{from}}, \code{\link{cc}}, \code{\link{bcc}} and \code{\link{reply}}
#' @export
#' @examples
#' # Create a message and set the keywords.
#' envelope() %>% keywords("newsletter, marketing")
#' envelope() %>% keywords("newsletter", "marketing")
#' envelope() %>% keywords(c("newsletter", "marketing"))
#'
#' # Retrieve the keywords for a message.
#' msg <- envelope() %>% keywords("newsletter, marketing")
#' keywords(msg)
keywords <- function(msg, ..., append = FALSE) {
   arguments <- c(...)
  if (is.null(arguments)) {
    header_get(msg, "Keywords")
  } else {
    msg <- header_set(msg, "Keywords", arguments, append = append, sep = ", ")
    if (get_option_invisible()) invisible(msg) else msg # nocov
  }
}

test_that("all header fields", {
  msg <- envelope() %>%
    subject("Test message") %>%
    to("frank@yahoo.co.uk") %>%
    cc("bob@gmail.com") %>%
    bcc("alice@yahoo.com") %>%
    from("olivia@google.com") %>%
    sender("olivia@gov.uk")
  expect_match(headers(msg), "Date: +.*\r\nX-Mailer: +\\{emayili\\}-[0-9]+\\.[0-9]+\\.[0-9]+\r\nMIME-Version: +1\\.0\r\nSubject: +Test message\r\nTo: +frank@yahoo.co.uk\r\nCc: +bob@gmail.com\r\nBcc: +alice@yahoo.com\r\nFrom: +olivia@google.com\r\nSender: +olivia@gov.uk")
})

test_that("generate parties table", {
  msg <- envelope() %>%
    to(address("gerry@gmail.com", "Gerald")) %>%
    from("jim@aol.com") %>%
    cc("alice@yahoo.com", "bob@yahoo.co.uk") %>%
    bcc("Erin <erin@yahoo.com>")

  addresses <- parties(msg)

  expect_type(addresses, "list")
  expect_equal(
    names(addresses),
    c("type", "address", "display", "raw", "local", "domain")
  )
})

test_that("invalid levels", {
  expect_error(envelope %>% sensitivity("none"), "Invalid")
})

test_that("set sensitivity", {
  expect_true(is.null(priority(envelope())))

  expect_equal(envelope() %>% sensitivity("personal") %>% sensitivity(), "personal")
})

test_that("set expires & reply-by", {
  with_tz({
    expect_match(
      envelope() %>% expires("2030-01-01 13:25:00", "UTC") %>% expires(),
      "Tue, 01 Jan 2030 13:25:00 \\+0000 \\(UTC|GMT\\)"
    )
    expect_match(
      envelope() %>% replyby("2021-12-25 06:00:00", "GMT") %>% replyby(),
      "Sat, 25 Dec 2021 06:00:00 \\+0000 \\(UTC|GMT\\)"
    )
  })
})

test_that("in-reply-to & references", {
  expect_match(
    envelope() %>% inreplyto("<6163c08e.1c69fb81.65b78.183c@mx.google.com>") %>% as.character(),
    "In-Reply-To: +<6163c08e.1c69fb81.65b78.183c@mx.google.com>"
  )
  expect_match(
    envelope() %>% subject("Test") %>% inreplyto("<6163c08e.1c69fb81.65b78.183c@mx.google.com>", "AW: ") %>% as.character(),
    "Subject: +AW: Test"
  )
  expect_match(
    envelope() %>% references("<6163c08e.1c69fb81.65b78.183c@mx.google.com>") %>% as.character(),
    "References: +<6163c08e.1c69fb81.65b78.183c@mx.google.com>"
  )
  expect_match(
    envelope() %>% subject("Test") %>% references("<6163c08e.1c69fb81.65b78.183c@mx.google.com>", "AW: ") %>% as.character(),
    "Subject: +AW: Test"
  )
})

test_that("return-path", {
  expect_equal(
    envelope() %>% return_path("bob@gmail.com") %>% return_path(),
    address("bob@gmail.com")
  )
})

test_that("comments", {
  msg <- envelope() %>% comments("Test message")
  expect_equal(comments(msg), "Test message")

  expect_match(
    envelope() %>% comments("Test comments") %>% as.character(),
    "Test comments"
  )
})

test_that("keywords", {
  msg <- envelope() %>% keywords("Test keyword")
  expect_equal(keywords(msg), "Test keyword")

  expect_match(
    envelope() %>% keywords("Test keyword") %>% as.character(),
    "Test keyword"
  )

  msg <- envelope() %>% keywords("Test keyword1, Test keyword2")
  expect_equal(keywords(msg), "Test keyword1, Test keyword2")

  expect_match(
    envelope() %>% keywords("Test keyword1, Test keyword2") %>% as.character(),
    "Test keyword1,[[:space:]]+Test keyword2"
  )

  msg <- envelope() %>% keywords(c("Test keyword1, Test keyword2"))
  expect_equal(keywords(msg), "Test keyword1, Test keyword2")

  expect_match(
    envelope() %>% keywords(c("Test keyword1, Test keyword2")) %>% as.character(),
    "Test keyword1,[[:space:]]+Test keyword2"
  )
})

#' Add fields for message importance and priority
#'
#' @name precedence
#'
#' @param msg A message object.
#' @return A message object.
NULL

#' Set message priority
#'
#' A hint to influence transmission speed and delivery.
#'
#' @rdname precedence
#' @param priority Priority level. One of \code{"non-urgent"}, \code{"normal"}, or \code{"urgent"}.
#'
#' @export
#'
#' @examples
#' # How rapidly does the message need to be delivered?
#' #
#' envelope() %>%
#'   subject("Deliver this immediately!") %>%
#'   priority("urgent")
#'
#' envelope(priority = "non-urgent") %>%
#'   subject("No rush with this.")
#'
priority <- function(msg, priority = NULL) {
  if (is.null(priority)) {
    header_get(msg, "Priority")
  } else {
    if (!(priority %in% LEVELS_PRIORITY)) {
      stop("Invalid priority. Options are: ", paste(LEVELS_PRIORITY, collapse = ", "), ".")
    }

    msg <- header_set(msg, "Priority", priority, append = FALSE)

    if (get_option_invisible()) invisible(msg) else msg # nocov
  }
}

#' Set message importance
#'
#' A hint to the message recipient about how important the message is.
#'
#' Does not influence transmission speed or delivery.
#'
#' @rdname precedence
#' @param importance Importance level. One of \code{"low"}, \code{"normal"}, or \code{"high"}.
#'
#' @export
#'
#' @examples
#' # How much attention should be paid by recipient?
#' #
#' envelope() %>%
#'   subject("Read this immediately!") %>%
#'   importance("high")
#'
#' envelope(importance = "low") %>%
#'   subject("Not important at all. Just delete.")
importance <- function(msg, importance = NULL) {
  if (is.null(importance)) {
    header_get(msg, "Importance")
  } else {
    if (!(importance %in% LEVELS_IMPORTANCE)) {
      stop("Invalid importance. Options are: ", paste(LEVELS_IMPORTANCE, collapse = ", "), ".")
    }

    msg <- header_set(msg, "Importance", importance, append = FALSE)

    if (get_option_invisible()) invisible(msg) else msg # nocov
  }
}

test_that("invalid levels", {
  expect_error(envelope %>% priority("none"), "Invalid")
  expect_error(envelope %>% importance("urgent"), "Invalid")
})

test_that("set priority", {
  expect_true(is.null(priority(envelope())))

  expect_equal(envelope() %>% priority("urgent") %>% priority(), "urgent")
  expect_equal(envelope(priority = "urgent") %>% priority(), "urgent")
})

test_that("set importance", {
  expect_true(is.null(importance(envelope())))

  expect_equal(envelope() %>% importance("high") %>% importance(), "high")
  expect_equal(envelope(importance = "high") %>% importance(), "high")
})

suppressPackageStartupMessages({
  library(here)
  library(logger)
  library(dplyr)
  require(htmltools, quietly = TRUE)
})

log_threshold(ERROR)

# Generate random folder name.
#
rndchar <- function(n = 24) {
  stringi::stri_rand_strings(1, n)
}

TXTPATH <- tempfile(fileext = ".txt")
CSSPATH <- tempfile(fileext = ".css")
HTMLPATH <- "hello.html"
RMD_TEMPLATE <- "vignette.Rmd"

# This file comes from https://bit.ly/2P4LUO8 (cat poster on WikiPedia).
#
JPGPATH <- system.file("cats.jpg", package = "emayili", mustWork = TRUE)
# If have not installed yet.
if (!file.exists(JPGPATH)) JPGPATH <- here("inst", "cats.jpg")

TXTCONTENT <- "Some random text."

PLAIN_MARKDOWN <- "## Section\n[link](https://www.google.com)"
PLAIN_MARKDOWN_INTERPOLATE <- "Hi {{name}}!"

COLOUR_GLAUCOUS = "#6082b6"

# Start with a blank slate.
#
source("teardown-files.R", local = TRUE)

# The , sep = "" prevents it from writing an "\n" at the end of the line.
writeLines(TXTCONTENT, TXTPATH, sep = "")
TXTCONTENT_ENCODED <- emayili:::mime_base64encode(charToRaw(TXTCONTENT))

writeLines(
  paste0("body {color: ", COLOUR_GLAUCOUS," !important;}"),
  CSSPATH
)

HTMLCONTENT <- "<p>Hello there, stranger!</p>"
#
writeLines(HTMLCONTENT, HTMLPATH)

SUBJECT <- rndchar(36)

# SERVER -----------------------------------------------------------------------

# Using fake SMTP server.
#
# - https://mailtrap.io/
# - https://www.smtpbucket.com/
#
SMTP_SERVER   = "mail.smtpbucket.com"
SMTP_PORT     = 8025
SMTP_USERNAME_GMAIL <- Sys.getenv("GMAIL_USERNAME", NA)
SMTP_PASSWORD_GMAIL <- Sys.getenv("GMAIL_PASSWORD", NA)
SMTP_PASSWORD_SENDGRID <- Sys.getenv("SENDGRID_API_KEY")
SMTP_USERNAME_MAILGUN <- Sys.getenv("MAILGUN_SMTP_USERNAME")
SMTP_PASSWORD_MAILGUN <- Sys.getenv("MAILGUN_SMTP_PASSWORD")
SMTP_USERNAME_SENDINBLUE <- Sys.getenv("SENDINBLUE_SMTP_USERNAME")
SMTP_PASSWORD_SENDINBLUE <- Sys.getenv("SENDINBLUE_SMTP_PASSWORD")
SMTP_USERNAME_MAILERSEND <- Sys.getenv("MAILERSEND_SMTP_USERNAME")
SMTP_PASSWORD_MAILERSEND <- Sys.getenv("MAILERSEND_SMTP_PASSWORD")

EMAIL_FROM <- ifelse(is.na(SMTP_USERNAME_GMAIL), "alice@gmail.com", SMTP_USERNAME_GMAIL)
EMAIL_TO <- ifelse(is.na(SMTP_USERNAME_GMAIL), "bob@yahoo.com", SMTP_USERNAME_GMAIL)

smtp <- server(
  host = SMTP_SERVER,
  port = SMTP_PORT
)
smtp_verbose <- server(
  host = SMTP_SERVER,
  port = SMTP_PORT,
  username = SMTP_USERNAME_GMAIL
)
smtp_insecure <- server(
  host = SMTP_SERVER,
  port = SMTP_PORT,
  username = SMTP_USERNAME_GMAIL,
  insecure = TRUE
)

if (is.na(SMTP_USERNAME_GMAIL) || is.na(SMTP_PASSWORD_GMAIL)) {
  smtp_gmail <- NA
} else {
  smtp_gmail <- gmail(
    username = SMTP_USERNAME_GMAIL,
    password = SMTP_PASSWORD_GMAIL
  )
}

smtp_sendgrid <- sendgrid(
  password = SMTP_PASSWORD_SENDGRID
)

smtp_mailgun <- mailgun(
  username = SMTP_USERNAME_MAILGUN,
  password = SMTP_PASSWORD_MAILGUN
)

smtp_sendinblue <- sendinblue(
  username = SMTP_USERNAME_SENDINBLUE,
  password = SMTP_PASSWORD_SENDINBLUE
)

smtp_mailersend <- mailersend(
  username = SMTP_USERNAME_MAILERSEND,
  password = SMTP_PASSWORD_MAILERSEND
)

# R MARKDOWN FILE --------------------------------------------------------------

# Create an Rmd document from template.
rmarkdown::draft(
  RMD_TEMPLATE,
  template = "html_vignette",
  package = "rmarkdown",
  edit = FALSE
)

# UTILITY ----------------------------------------------------------------------

skip_if_neither_installed <- function(paks) {
  are_there <- vapply(
    paks,
    requireNamespace,
    FUN.VALUE = logical(1),
    quietly  = TRUE
  )
  if (!any(are_there)) {
    testthat::skip(
      sprintf(
        "None of {%s} are installed",
        paste(paks, collapse = "} or {")
      )
    )
  }
}

with_tz <- function(code) {
  old_tz <- Sys.getenv("TZ")
  on.exit(
    Sys.setenv("TZ" = old_tz)
  )
  Sys.setenv(TZ = "UTC")
  force(code)
}

#' Request read receipt
#'
#' Request the recipient to acknowledge that they have read the message. Inserts
#' MDN (Message Disposition Notification) header entries.
#'
#' @param msg A message object.
#' @param addr Single address.
#' @return A message object.
#' @export
request_receipt_read <- function(msg, addr = NULL) {
  if (is.null(addr)) addr <- from(msg)
  if (is.null(addr)) stop("Either specify receipt address or call from() first.")

  msg <- header_set(msg, "Return-Receipt-To", as.address(addr), append = FALSE)
  msg <- header_set(msg, "Disposition-Notification-To", as.address(addr), append = FALSE)
  msg <- header_set(msg, "X-Confirm-Reading-To", as.address(addr), append = FALSE)

  if (get_option_invisible()) invisible(msg) else msg # nocov
}

# https://www.ddrive.no/post/making-hex-and-twittercard-with-bunny-and-magick/

library(magick)
# remotes::install_github("dmi3kno/bunny")
library(bunny)

hex <- image_read(here::here("man/figures/emayili-hex.png")) %>%
  image_scale("400x400")

gh_logo <- bunny::github %>% image_scale("50x50")

gh_card <- image_canvas_ghcard("#ffffff") %>%
  image_compose(hex, gravity = "East", offset = "+100+0") %>%
  image_annotate("emayili: Email from R", gravity = "West", location = "+100-30", color="#0d4448", size=50, font="Roboto Slab") %>%
  image_compose(gh_logo, gravity="West", offset = "+100+45") %>%
  image_annotate("datawookie/emayili", gravity="West", location="+160+45", size=50, font="Ubuntu Mono") %>%
  image_border_ghcard("#8b9196")

gh_card

gh_card %>%
  image_write(here::here("man/figures/emayili-github-card.png"))

# Example text from https://en.wikipedia.org/wiki/Quoted-printable.
#
encoded <- "J'interdis aux marchands de vanter trop leurs marchandises. Car ils se font=\n vite p=C3=A9dagogues et t'enseignent comme but ce qui n'est par essence qu=\n'un moyen, et te trompant ainsi sur la route =C3=A0 suivre les voil=C3=A0 b=\nient=C3=B4t qui te d=C3=A9gradent, car si leur musique est vulgaire ils te =\nfabriquent pour te la vendre une =C3=A2me vulgaire."
decoded <- "J'interdis aux marchands de vanter trop leurs marchandises. Car ils se font vite pédagogues et t'enseignent comme but ce qui n'est par essence qu'un moyen, et te trompant ainsi sur la route à suivre les voilà bientôt qui te dégradent, car si leur musique est vulgaire ils te fabriquent pour te la vendre une âme vulgaire."

# Can generate other test text at https://www.webatic.com/quoted-printable-convertor.

test_that("(en|de)code text", {
  local_reproducible_output(unicode = TRUE)

  expect_equal(qp_encode(decoded), encoded)
  expect_equal(qp_decode(encoded), decoded)
})

test_that("(en|de)code '='", {
  expect_equal(qp_encode("= =="), "=3D =3D=3D")
  expect_equal(qp_decode("=3D =3D=3D"), "= ==")
})

test_that("don't break lines in token", {
  expect_equal(qp_encode("========================="), "=3D=3D=3D=3D=3D=3D=3D=3D=3D=3D=3D=3D=3D=3D=3D=3D=3D=3D=3D=3D=3D=3D=3D=3D=3D")
  expect_equal(qp_encode(" ========================="), " =3D=3D=3D=3D=3D=3D=3D=3D=3D=3D=3D=3D=3D=3D=3D=3D=3D=3D=3D=3D=3D=3D=3D=3D=\n=3D")
  expect_equal(qp_encode("  ========================="), "  =3D=3D=3D=3D=3D=3D=3D=3D=3D=3D=3D=3D=3D=3D=3D=3D=3D=3D=3D=3D=3D=3D=3D=3D=\n=3D")
  expect_equal(qp_encode("   ========================="), "   =3D=3D=3D=3D=3D=3D=3D=3D=3D=3D=3D=3D=3D=3D=3D=3D=3D=3D=3D=3D=3D=3D=3D=3D=\n=3D")
  expect_equal(qp_encode("    ========================="), "    =3D=3D=3D=3D=3D=3D=3D=3D=3D=3D=3D=3D=3D=3D=3D=3D=3D=3D=3D=3D=3D=3D=3D=\n=3D=3D")
})

test_that("unicode", {
  local_reproducible_output(unicode = TRUE)

  expect_equal(Encoding(qp_decode("=E3=83=84")), Encoding("ツ"))
  expect_equal(qp_decode("=E3=83=84"), "ツ")
})

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/mime.R
\name{mime-parameters}
\alias{mime-parameters}
\title{Parameters for MIME functions}
\arguments{
\item{content}{A string of message content.}

\item{disposition}{Should the content be displayed inline or as an
attachment? Valid options are \code{"inline"} and \code{"attachment"}. If
set to \code{NA} then will guess appropriate value.}

\item{charset}{What character set is used. Most often either \code{"UTF-8"}
or \code{"ISO-8859-1"}.}

\item{encoding}{How content is transformed to ASCII. Options are
\code{"7bit"}, \code{"quoted-printable"} and \code{"base64"}. Use \code{NA}
or \code{NULL} for no (or "identity") encoding.}

\item{language}{Langauge of content. If \code{FALSE} then will not include
language field. If \code{TRUE} then will attempt to auto-detect language.
Otherwise will use the specified language.}

\item{description}{Description of content.}

\item{name}{Name used when downloading file.}

\item{filename}{Path to a file.}

\item{boundary}{Boundary string.}

\item{type}{The MIME type of the content.}

\item{children}{List of child MIME objects.}

\item{interpolate}{Whether or not to interpolate into input using \link[glue]{glue}.}

\item{.open}{The opening delimiter.}

\item{.close}{The closing delimiter.}

\item{.envir}{Environment used for \code{glue} interpolation. Defaults to \code{parent.frame()}.}
}
\description{
These are parameters which occur commonly across functions for components of
a MIME document.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/header-mail.R
\name{addresses}
\alias{addresses}
\alias{to}
\alias{cc}
\alias{bcc}
\alias{from}
\alias{reply}
\alias{return_path}
\alias{sender}
\title{Add address fields to message}
\usage{
to(msg, ..., append = TRUE)

cc(msg, ..., append = TRUE)

bcc(msg, ..., append = TRUE)

from(msg, addr = NULL)

reply(msg, addr = NULL)

return_path(msg, addr = NULL)

sender(msg, addr = NULL)
}
\arguments{
\item{msg}{A message object.}

\item{...}{Addresses.}

\item{append}{Whether to append or replace addresses.}

\item{addr}{Single address.}
}
\value{
A message object.
}
\description{
Add address fields to message
}
\examples{
# Populating the To field.
msg <- envelope()
msg \%>\% to("bob@gmail.com, alice@yahoo.com")
msg \%>\% to("bob@gmail.com", "alice@yahoo.com")
msg \%>\% to(c("bob@gmail.com", "alice@yahoo.com"))

# Populating the Cc field.
msg <- envelope()
msg \%>\% cc("bob@gmail.com, alice@yahoo.com")
msg \%>\% cc("bob@gmail.com", "alice@yahoo.com")
msg \%>\% cc(c("bob@gmail.com", "alice@yahoo.com"))

# Populating the Bcc field.
msg <- envelope()
msg \%>\% bcc("bob@gmail.com, alice@yahoo.com")
msg \%>\% bcc("bob@gmail.com", "alice@yahoo.com")
msg \%>\% bcc(c("bob@gmail.com", "alice@yahoo.com"))

msg <- envelope()

# Populating the From field.
msg \%>\% from("craig@gmail.com")

# Populating the Reply-To field.
msg <- envelope()
msg \%>\% reply("gerry@gmail.com")

# Populating the Return-Path field.
msg <- envelope()
msg \%>\% return_path("bounced-mail@devnull.org")

# Populating the Sender field.
msg <- envelope()
msg \%>\% sender("on_behalf_of@gmail.com")
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/address.R
\name{domain}
\alias{domain}
\title{Extract domain of email address}
\usage{
domain(addr)
}
\arguments{
\item{addr}{An \code{address} object.}
}
\value{
A character vector.
}
\description{
Extract domain of email address
}
\examples{
domain("alice@example.com")
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/header.R
\name{as.character.header}
\alias{as.character.header}
\title{Create formatted header.}
\usage{
\method{as.character}{header}(x, width = 28, ...)
}
\arguments{
\item{x}{A header object.}

\item{width}{The width of the head name field.}

\item{...}{Further arguments passed to or from other methods.}
}
\value{
A formatted header field.
}
\description{
Accepts a header object and formats it as a header field.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/address.R
\name{as.address}
\alias{as.address}
\title{Create an address object}
\usage{
as.address(addr)
}
\arguments{
\item{addr}{An email address.}
}
\value{
An \code{address} object.
}
\description{
Create an address object
}
\examples{
as.address("gerry@gmail.com")
as.address("Gerald <gerry@gmail.com>")
as.address(c("Gerald <gerry@gmail.com>", "alice@yahoo.com", "jim@aol.com"))
as.address("Gerald <gerry@gmail.com>, alice@yahoo.com, jim@aol.com")
as.address(c("Gerald <gerry@gmail.com>", "alice@yahoo.com, jim@aol.com"))
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/header-mail.R
\name{comments}
\alias{comments}
\title{Add or query comments of message.}
\usage{
comments(msg, comments = NULL)
}
\arguments{
\item{msg}{A message object.}

\item{comments}{Comments for the message.}
}
\value{
A message object or the comments of the message object (if \code{comments} is \code{NULL}).
}
\description{
Add or query comments of message.
}
\examples{
# Create a message and set the comments.
msg <- envelope() \%>\% comments("This is a comment")

# Retrieve the comments for a message.
comments(msg)
}
\seealso{
\code{\link{subject}}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/header-mail.R
\name{response}
\alias{response}
\alias{inreplyto}
\alias{references}
\title{Add In-Reply-To and References header fields}
\usage{
inreplyto(msg, msgid, subject_prefix = "Re: ")

references(msg, msgid, subject_prefix = "Re: ")
}
\arguments{
\item{msg}{A message object.}

\item{msgid}{A message ID. This would be the contents of the \code{Message-ID}
field from another message.}

\item{subject_prefix}{Prefix to add to subject. If specified will be prepended
onto the \code{Subject} field. Set to \code{NULL} if not required.}
}
\value{
A message object.
}
\description{
Add In-Reply-To and References header fields
}
\examples{
envelope() \%>\% inreplyto("<6163c08e.1c69fb81.65b78.183c@mx.google.com>")
# Now for German.
envelope() \%>\%
  inreplyto("6163c08e.1c69fb81.65b78.183c@mx.google.com", "AW: ")
# And also for Danish, Norwegian and Swedish (but not Finnish!).
envelope() \%>\%
  references("6163c08e.1c69fb81.65b78.183c@mx.google.com", "SV: ")
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/header-mail.R
\name{subject}
\alias{subject}
\title{Add or query subject of message.}
\usage{
subject(
  msg,
  subject = NULL,
  interpolate = TRUE,
  .open = "{{",
  .close = "}}",
  .envir = NULL
)
}
\arguments{
\item{msg}{A message object.}

\item{subject}{A subject for the message.}

\item{interpolate}{Whether or not to interpolate into input using \link[glue]{glue}.}

\item{.open}{The opening delimiter.}

\item{.close}{The closing delimiter.}

\item{.envir}{Environment used for \code{glue} interpolation. Defaults to \code{parent.frame()}.}
}
\value{
A message object or the subject of the message object (if \code{subject} is \code{NULL}).
}
\description{
Add or query subject of message.
}
\examples{
# Create a message and set the subject
msg <- envelope() \%>\% subject("Updated report")

# Retrieve the subject for a message
subject(msg)
}
\seealso{
\code{\link{to}}, \code{\link{from}}, \code{\link{cc}}, \code{\link{bcc}} and \code{\link{reply}}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/server.R
\name{server}
\alias{server}
\alias{gmail}
\alias{sendgrid}
\alias{mailgun}
\alias{sendinblue}
\alias{mailersend}
\title{Create a SMTP server object.}
\usage{
server(
  host,
  port = 25,
  username = NULL,
  password = NULL,
  insecure = FALSE,
  reuse = TRUE,
  helo = NA,
  protocol = NA,
  pause_base = 1,
  max_times = 5,
  ...
)

gmail(username, password, ...)

sendgrid(password, ...)

mailgun(username, password, ...)

sendinblue(username, password, ...)

mailersend(username, password, ...)
}
\arguments{
\item{host}{DNS name or IP address of the SMTP server.}

\item{port}{Port that the SMTP server is listening on.}

\item{username}{Username for SMTP server.}

\item{password}{Password for SMTP server or API key.}

\item{insecure}{Whether to ignore SSL issues.}

\item{reuse}{Whether the connection to the SMTP server should be left open for reuse.}

\item{helo}{The HELO domain name of the sending host. If left as \code{NA} then will use local host name.}

\item{protocol}{Which protocol (SMTP or SMTPS) to use for communicating with
the server. Default will choose appropriate protocol based on port.}

\item{pause_base}{Base delay (in seconds) for exponential backoff. See \link[purrr]{rate_backoff}.}

\item{max_times}{Maximum number of times to retry.}

\item{...}{Additional curl options. See \code{curl::curl_options()} for a list of supported options.}
}
\value{
A function which is used to send messages to the server.
}
\description{
Create a SMTP server object.
}
\section{Sendgrid}{


To use SendGrid you'll need to first \href{https://docs.sendgrid.com/for-developers/sending-email/integrating-with-the-smtp-api}{create an API key}.
Then use the API key as the password.

SendGrid will accept messages on ports 25, 587 and 2525 (using SMTP) as well
as 465 (using SMTPS).
}

\section{Mailgun}{


To use Mailgun you'll need to first register a sender domain. This will then
be assigned a username and password.

Mailgun will accept messages on ports 25 and 587 (using SMTP) as well as 465
(using SMTPS).
}

\section{Sendinblue}{


To use Sendinblue you'll need to first create an account. You'll find your
SMTP username and password in the SMTP & API section of your account
settings.
}

\section{MailerSend}{


To use MailerSend you'll need to first create an account. You'll find your
SMTP username and password under Domains. See \href{https://www.mailersend.com/help/smtp-relay}{How to send emails via SMTP with MailerSend}.

Although this is not likely to be a problem in practice, MailerSend insists
that all messages have at minimum a valid subject and either text or HTML
content.
}

\examples{
# Set parameters for SMTP server (with username and password).
smtp <- server(
  host = "smtp.gmail.com",
  port = 587,
  username = "bob@gmail.com",
  password = "bd40ef6d4a9413de9c1318a65cbae5d7"
)

# Set parameters for a (fake) testing SMTP server.
#
# More information about this service can be found at https://www.smtpbucket.com/.
#
smtp <- server(
  host = "mail.smtpbucket.com",
  port = 8025
)

# Create a message
msg <- envelope() \%>\%
  from("bob@gmail.com") \%>\%
  to("alice@yahoo.com")

# Send message (verbose output from interactions with server)
\dontrun{
smtp(msg, verbose = TRUE)
}

# To confirm that the message was sent, go to https://www.smtpbucket.com/ then:
#
# - fill in "bob@gmail.com" for the Sender field and
# - fill in "alice@yahoo.com" for the Recipient field then
# - press the Search button.

# With explicit HELO domain.
#
smtp <- server(host = "mail.example.com",
               helo = "client.example.com")

# Set parameters for Gmail SMTP server. The host and port are implicit.
smtp <- gmail(
  username = "bob@gmail.com",
  password = "bd40ef6d4a9413de9c1318a65cbae5d7"
)

# Set API key for SendGrid SMTP server.
smtp <- sendgrid(
  password = "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"
)

# Set username and password for Mailgun SMTP server.
smtp <- mailgun(
  username = "postmaster@sandbox9ptce35fdf0b31338dec4284eb7aaa59.mailgun.org",
  password = "44d072e7g2b5f3bf23b2b642da0fe3a7-2ac825a1-a5be680a"
)

# Set username and password for Sendinblue SMTP server.
smtp <- sendinblue(
  username = "bob@gmail.com",
  password = "xsmtpsib-c75cf91323adc53a1747c005447cbc9a893c35888635bb7bef1a624bf773da33"
)

# Set username and password for MailerSend SMTP server.
smtp <- mailersend(
  username = "NS_Pf3ALM@gmail.com",
  password = "e5ATWLlTnWWDaKeE"
)
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/encoding.R
\name{qp}
\alias{qp}
\alias{qp_encode}
\alias{qp_decode}
\title{Quoted-Printable encoding}
\usage{
qp_encode(x, crlf = CRLF)

qp_decode(x)
}
\arguments{
\item{x}{A string for encoding or decoding.}

\item{crlf}{End-of-line characters.}
}
\value{
An encoded string for \code{qp_encode()} or a decoded string for \code{qp_decode()}.
}
\description{
Encode to and decode from Quoted-Printable encoding.
}
\examples{
qp_encode("Mieux vaut être seul que mal accompagné.")
qp_decode("Mieux vaut =C3=AAtre seul que mal accompagn=C3=A9.")
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/address.R
\name{local}
\alias{local}
\title{Extract local part of email address}
\usage{
local(addr)
}
\arguments{
\item{addr}{An \code{address} object.}
}
\value{
A character vector.
}
\description{
Extract local part of email address
}
\examples{
local("alice@example.com")
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/header-expires.R
\name{cutoff}
\alias{cutoff}
\alias{expires}
\alias{replyby}
\title{Set or query message expiry or reply-by time}
\usage{
expires(msg, datetime = NULL, tz = "")

replyby(msg, datetime = NULL, tz = "")
}
\arguments{
\item{msg}{A message object.}

\item{datetime}{Date and time.}

\item{tz}{A character string specifying the time zone.}
}
\value{
A message object.
}
\description{
Functions to specify the time at which a message expires or by which a reply
is requested.
}
\details{
Manipulate the \code{Expires} and \code{Reply-By} fields as specified in
\href{https://www.ietf.org/rfc/rfc2156.txt}{RFC 2156}.
}
\examples{
envelope() \%>\%
  expires("2030-01-01 13:25:00", "UTC")
envelope() \%>\%
  replyby("2021-12-25 06:00:00", "GMT")
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/attachment.R
\name{attachment}
\alias{attachment}
\title{Add attachments to a message object}
\usage{
attachment(
  msg,
  path,
  name = NA,
  type = NA,
  cid = NA,
  disposition = "attachment"
)
}
\arguments{
\item{msg}{A message object.}

\item{path}{Path to file.}

\item{name}{Name to be used for attachment (defaults to base name of \code{path}).}

\item{type}{MIME type or \cite{NA}, which will result in a guess based on file extension.}

\item{cid}{Content-ID or \code{NA}.}

\item{disposition}{How is attachment to be presented (\code{"inline"} or \code{"attachment"})?}
}
\value{
A message object.
}
\description{
Add attachments to a message object
}
\examples{
path_mtcars  <- tempfile(fileext = ".csv")
path_scatter <- tempfile(fileext = ".png")
path_cats    <- system.file("cats.jpg", package = "emayili")

write.csv(mtcars, path_mtcars)

png(path_scatter)
plot(1:10)
dev.off()

msg <- envelope() \%>\%
  attachment(path_mtcars) \%>\%
  # This attachment will have file name "cats.jpg".
  attachment(path_cats, name = "cats.jpg", type = "image/jpeg") \%>\%
  attachment(path_scatter, cid = "scatter")

file.remove(path_scatter, path_mtcars)
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/mime.R
\name{as.character.MIME}
\alias{as.character.MIME}
\title{Convert MIME object to character vector}
\usage{
\method{as.character}{MIME}(x, ...)
}
\arguments{
\item{x}{MIME object}

\item{...}{Further arguments passed to or from other methods.}
}
\description{
Convert MIME object to character vector
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/envelope.R
\name{append.envelope}
\alias{append.envelope}
\title{Append children to message}
\usage{
\method{append}{envelope}(x, child)
}
\arguments{
\item{x}{Message object}

\item{child}{A child to be appended}
}
\description{
Append children to message
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/address.R
\name{print.vctrs_address}
\alias{print.vctrs_address}
\title{Print an address object}
\usage{
\method{print}{vctrs_address}(x, ...)
}
\arguments{
\item{x}{An \code{address} object.}

\item{...}{Further arguments passed to or from other methods.}
}
\description{
Print an address object
}
\examples{
gerry <- as.address("gerry@gmail.com")
print(gerry)
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/body.R
\name{html}
\alias{html}
\title{Add an HTML body to a message object.}
\usage{
html(
  msg,
  content,
  disposition = "inline",
  charset = "utf-8",
  encoding = "quoted-printable",
  css_files = c(),
  language = FALSE,
  interpolate = TRUE,
  .open = "{{",
  .close = "}}",
  .envir = NULL
)
}
\arguments{
\item{msg}{A message object.}

\item{content}{A string of message content.}

\item{disposition}{Should the content be displayed inline or as an
attachment? Valid options are \code{"inline"} and \code{"attachment"}. If
set to \code{NA} then will guess appropriate value.}

\item{charset}{What character set is used. Most often either \code{"UTF-8"}
or \code{"ISO-8859-1"}.}

\item{encoding}{How content is transformed to ASCII. Options are
\code{"7bit"}, \code{"quoted-printable"} and \code{"base64"}. Use \code{NA}
or \code{NULL} for no (or "identity") encoding.}

\item{css_files}{Extra CSS files.}

\item{language}{Langauge of content. If \code{FALSE} then will not include
language field. If \code{TRUE} then will attempt to auto-detect language.
Otherwise will use the specified language.}

\item{interpolate}{Whether or not to interpolate into input using \link[glue]{glue}.}

\item{.open}{The opening delimiter.}

\item{.close}{The closing delimiter.}

\item{.envir}{Environment used for \code{glue} interpolation. Defaults to \code{parent.frame()}.}
}
\value{
A message object.
}
\description{
Add an HTML body to a message object.
}
\examples{
# Inline HTML message.
envelope() \%>\% html("<b>Hello!</b>")

# Read HTML message from a file.
htmlfile <- tempfile(fileext = ".html")
cat("<p>Hello!</p>\n", file = htmlfile)
envelope() \%>\% html(htmlfile)

# You can pass a vector of character. Components will be separated by a
# "\n".
envelope() \%>\% html(c("<b>Hello</b>", "<p>World!</p>"))

# You can also pass a tagList from {htmltools}.
if (requireNamespace("htmltools", quietly = TRUE)) {
  library(htmltools)
  envelope() \%>\% html(tagList(h2("Hello"), p("World!")))
}
}
\seealso{
\code{\link{text}}, \code{\link{render}}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/utils.R
\name{compare}
\alias{compare}
\title{Compare vectors}
\usage{
compare(lhs, rhs)
}
\arguments{
\item{lhs}{LHS of operation.}

\item{rhs}{RHS of operation.}
}
\value{
A Boolean value.
}
\description{
Returns \code{TRUE} wherever elements are the same (including \code{NA}),
and \code{FALSE} everywhere else.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/envelope.R
\name{envelope}
\alias{envelope}
\title{Create a message.}
\usage{
envelope(
  to = NULL,
  from = NULL,
  cc = NULL,
  bcc = NULL,
  reply = NULL,
  subject = NULL,
  importance = NULL,
  priority = NULL,
  text = NULL,
  html = NULL,
  encrypt = FALSE,
  sign = FALSE,
  public_key = FALSE
)
}
\arguments{
\item{to}{See \code{\link[=to]{to()}}.}

\item{from}{See \code{\link[=from]{from()}}.}

\item{cc}{See \code{\link[=cc]{cc()}}.}

\item{bcc}{See \code{\link[=bcc]{bcc()}}.}

\item{reply}{See \code{\link[=reply]{reply()}}.}

\item{subject}{See \code{\link[=subject]{subject()}}.}

\item{importance}{See \code{\link[=importance]{importance()}}.}

\item{priority}{See \code{\link[=priority]{priority()}}.}

\item{text}{See \code{\link[=text]{text()}}.}

\item{html}{See \code{\link[=html]{html()}}.}

\item{encrypt}{Whether to encrypt the message. If \code{TRUE} then the entire
message will be encrypted using the private key of the sender.}

\item{sign}{Whether to sign the message. If \code{TRUE} then the entire message will be signed using the private key of the sender.}

\item{public_key}{Whether to attach a public key. If \code{TRUE} then the public key of the sender will be attached.}
}
\value{
A message object.
}
\description{
Create a message.
}
\examples{
# Create an (empty) message object.
#
msg <- envelope()

# Create a complete message object, specifying all available fields.
#
envelope(
  to = "bob@gmail.com",
  from = "craig@gmail.com",
  cc = "alex@gmail.com",
  bcc = "shannon@gmail.com",
  reply = "craig@yahoo.com",
  importance = "high",
  priority = "urgent",
  subject = "Hiya!",
  text = "Hi Bob, how are you?"
)
}
\seealso{
\code{\link[=subject]{subject()}}, \code{\link[=from]{from()}}, \code{\link[=to]{to()}}, \code{\link[=cc]{cc()}}, \code{\link[=bcc]{bcc()}}, \code{\link[=reply]{reply()}} and
\code{\link[=encrypt]{encrypt()}}.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/address.R
\name{display}
\alias{display}
\title{Extract display name}
\usage{
display(addr)
}
\arguments{
\item{addr}{An \code{address} object.}
}
\value{
The display name or \code{NA}.
}
\description{
Extracts the display name from an email address.
}
\examples{
gerry <- as.address("Gerald <gerry@gmail.com>")
display(gerry)
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/address.R
\name{compliant}
\alias{compliant}
\title{Tests whether an email address is syntactically correct}
\usage{
compliant(addr, error = FALSE)
}
\arguments{
\item{addr}{An email address.}

\item{error}{Whether to create an error if not compliant.}
}
\value{
A Boolean.
}
\description{
Checks whether an email address conforms to the \href{https://en.wikipedia.org/wiki/Email_address#Syntax}{syntax rules}.
}
\details{
An email address may take either of the following forms:
\itemize{
\item \code{local@domain} or
\item \verb{Display Name <local@domain>}.
}
}
\examples{
compliant("alice@example.com")
compliant("alice?example.com")
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/encrypt.R
\name{encrypt}
\alias{encrypt}
\title{Encrypt or sign a message}
\usage{
encrypt(msg, encrypt = TRUE, sign = TRUE, public_key = TRUE)
}
\arguments{
\item{msg}{A message object.}

\item{encrypt}{Whether to encrypt the message. If \code{TRUE} then the entire
message will be encrypted using the private key of the sender.}

\item{sign}{Whether to sign the message. If \code{TRUE} then the entire message will be signed using the private key of the sender.}

\item{public_key}{Whether to attach a public key. If \code{TRUE} then the public key of the sender will be attached.}
}
\value{
A message object.
}
\description{
Specify whether the message should be encrypted, signed or have a public key attached.
}
\details{
If a recipient's email client is unable to decrypt an encrypted message then they will not be able to access the message contents.
}
\examples{
\dontrun{
msg <- envelope(
  to = "schunk@u-boat.com",
  subject = "Top Secret Message",
  text = "Immediate readiness. There are indications that the invasion has begun."
)
msg \%>\% encrypt()
}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/parties.R
\name{parties}
\alias{parties}
\title{Extract sender and recipient(s)}
\usage{
parties(msg)
}
\arguments{
\item{msg}{A message object.}
}
\value{
A tibble.
}
\description{
Extract sender and recipient(s)
}
\examples{
email <- envelope() \%>\%
  from("Gerald <gerald@gmail.com>") \%>\%
  to(c("bob@gmail.com", "alice@yahoo.com")) \%>\%
  cc("Craig     < craig@gmail.com>") \%>\%
  bcc("  Erin   <erin@yahoo.co.uk    >")

parties(email)
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/envelope.R
\name{print.envelope}
\alias{print.envelope}
\title{Print a message object}
\usage{
\method{print}{envelope}(x, details = NA, ...)
}
\arguments{
\item{x}{A message object.}

\item{details}{Whether or not to display full message content.}

\item{...}{Further arguments passed to or from other methods.}
}
\description{
The message body will be printed if \code{details} is \code{TRUE} or if the \code{envelope_details}
option is \code{TRUE}.
}
\examples{
msg <- envelope() \%>\% text("Hello, World!")

print(msg)
print(msg, details = TRUE)

options(envelope_details = TRUE)
print(msg)
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/address.R
\name{new_address}
\alias{new_address}
\title{Helper function for creating address objects}
\usage{
new_address(
  email = character(),
  display = character(),
  local = character(),
  domain = character(),
  normalise = TRUE
)
}
\arguments{
\item{email}{Email address.}

\item{display}{Display name.}

\item{local}{Local part of email address.}

\item{domain}{Domain part of email address.}

\item{normalise}{Whether to try to normalise address to RFC-5321 requirements.}
}
\value{
An \code{address} object, representing an email address.
}
\description{
Helper function for creating address objects
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/header-precedence.R
\name{precedence}
\alias{precedence}
\alias{priority}
\alias{importance}
\title{Add fields for message importance and priority}
\usage{
priority(msg, priority = NULL)

importance(msg, importance = NULL)
}
\arguments{
\item{msg}{A message object.}

\item{priority}{Priority level. One of \code{"non-urgent"}, \code{"normal"}, or \code{"urgent"}.}

\item{importance}{Importance level. One of \code{"low"}, \code{"normal"}, or \code{"high"}.}
}
\value{
A message object.
}
\description{
A hint to influence transmission speed and delivery.

A hint to the message recipient about how important the message is.
}
\details{
Does not influence transmission speed or delivery.
}
\examples{
# How rapidly does the message need to be delivered?
#
envelope() \%>\%
  subject("Deliver this immediately!") \%>\%
  priority("urgent")

envelope(priority = "non-urgent") \%>\%
  subject("No rush with this.")

# How much attention should be paid by recipient?
#
envelope() \%>\%
  subject("Read this immediately!") \%>\%
  importance("high")

envelope(importance = "low") \%>\%
  subject("Not important at all. Just delete.")
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/header-mail.R
\name{keywords}
\alias{keywords}
\title{Add or query keywords of message.}
\usage{
keywords(msg, ..., append = FALSE)
}
\arguments{
\item{msg}{A message object.}

\item{...}{Keywords.}

\item{append}{Whether to append or replace keywords.}
}
\value{
A message object or the comments of the message object (if \code{comments} is \code{NULL}).
}
\description{
Add or query keywords of message.
}
\examples{
# Create a message and set the keywords.
envelope() \%>\% keywords("newsletter, marketing")
envelope() \%>\% keywords("newsletter", "marketing")
envelope() \%>\% keywords(c("newsletter", "marketing"))

# Retrieve the keywords for a message.
msg <- envelope() \%>\% keywords("newsletter, marketing")
keywords(msg)
}
\seealso{
\code{\link{to}}, \code{\link{from}}, \code{\link{cc}}, \code{\link{bcc}} and \code{\link{reply}}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/header-sensitivity.R
\name{sensitivity}
\alias{sensitivity}
\title{Set or query message sensitivity}
\usage{
sensitivity(msg, sensitivity = NULL)
}
\arguments{
\item{msg}{A message object.}

\item{sensitivity}{Sensitivity level. One of \code{"personal"}, \code{"private"}, or \code{"company-confidential"}.}
}
\value{
A message object.
}
\description{
Manipulate the \code{Sensitivity} field as specified in \href{https://www.ietf.org/rfc/rfc2156.txt}{RFC 2156}.
}
\examples{
# Not sensitive.
envelope() \%>\%
  subject("Your daily dose of spam")

# Sensitive personal message.
envelope() \%>\%
  subject("The results from your test") \%>\%
  sensitivity("personal")

# Sensitive private message.
envelope() \%>\%
  subject("Your OTP (don't show this to anybody!") \%>\%
  sensitivity("private")

# Sensitive business message.
envelope() \%>\%
  subject("Top Secret Strategy Document") \%>\%
  sensitivity("company-confidential")

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/address.R
\name{raw}
\alias{raw}
\title{Extract raw email address}
\usage{
raw(addr)
}
\arguments{
\item{addr}{An \code{address} object.}
}
\value{
A raw email address.
}
\description{
Strips the display name off an email address (if present).
}
\examples{
gerry <- as.address("Gerald <gerry@gmail.com>")
raw(gerry)
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/body.R
\name{text}
\alias{text}
\title{Add a text body to a message.}
\usage{
text(
  msg,
  content,
  disposition = "inline",
  charset = "utf-8",
  encoding = "7bit",
  language = FALSE,
  interpolate = TRUE,
  .open = "{{",
  .close = "}}",
  .envir = NULL
)
}
\arguments{
\item{msg}{A message object.}

\item{content}{A string of message content.}

\item{disposition}{Should the content be displayed inline or as an
attachment? Valid options are \code{"inline"} and \code{"attachment"}. If
set to \code{NA} then will guess appropriate value.}

\item{charset}{What character set is used. Most often either \code{"UTF-8"}
or \code{"ISO-8859-1"}.}

\item{encoding}{How content is transformed to ASCII. Options are
\code{"7bit"}, \code{"quoted-printable"} and \code{"base64"}. Use \code{NA}
or \code{NULL} for no (or "identity") encoding.}

\item{language}{Langauge of content. If \code{FALSE} then will not include
language field. If \code{TRUE} then will attempt to auto-detect language.
Otherwise will use the specified language.}

\item{interpolate}{Whether or not to interpolate into input using \link[glue]{glue}.}

\item{.open}{The opening delimiter.}

\item{.close}{The closing delimiter.}

\item{.envir}{Environment used for \code{glue} interpolation. Defaults to \code{parent.frame()}.}
}
\value{
A message object.
}
\description{
Add \code{text/plain} content to a message.
}
\details{
The \code{text/plain} format is
described in \href{https://www.ietf.org/rfc/rfc2646.txt}{RFC 2646}.

Uses \code{glue::glue()} to evaluate expressions enclosed in brackets as R code.
}
\examples{
msg <- envelope() \%>\% text("Hello!")

# Using {glue} interpolation.
#
name <- "Alice"
msg <- envelope() \%>\% text("Hello {name}.")

print(msg, details = TRUE)

# Disable {glue} interpolation.
#
msg <- envelope() \%>\% text("This is a set: {1, 2, 3}.", interpolate = FALSE)
}
\seealso{
\code{\link{html}}, \code{\link{render}}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/address.R
\name{as.character.vctrs_address}
\alias{as.character.vctrs_address}
\title{Convert address object to character}
\usage{
\method{as.character}{vctrs_address}(x, ...)
}
\arguments{
\item{x}{A vector of \code{address} objects.}

\item{...}{Further arguments passed to or from other methods.}
}
\value{
A character vector.
}
\description{
Convert address object to character
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/envelope.R
\name{as.character.envelope}
\alias{as.character.envelope}
\title{Create formatted message.}
\usage{
\method{as.character}{envelope}(x, ..., details = TRUE)
}
\arguments{
\item{x}{A message object.}

\item{...}{Further arguments passed to or from other methods.}

\item{details}{Whether or not to display full message content.}
}
\value{
A formatted message object.
}
\description{
Accepts a message object and formats it as a MIME document.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/render.R
\name{render}
\alias{render}
\title{Render Markdown into email}
\usage{
render(
  msg,
  input,
  params = NULL,
  squish = TRUE,
  css_files = c(),
  include_css = c("rmd", "bootstrap", "highlight"),
  language = FALSE,
  interpolate = TRUE,
  .open = "{{",
  .close = "}}",
  .envir = NULL
)
}
\arguments{
\item{msg}{A message object.}

\item{input}{The input Markdown file to be rendered or a character vector of Markdown text.}

\item{params}{A list of named parameters that override custom parameters specified in the YAML front-matter.}

\item{squish}{Whether to clean up whitespace in rendered document.}

\item{css_files}{Extra CSS files.}

\item{include_css}{Whether to include rendered CSS from various sources (\code{"rmd"} — native R Markdown CSS; \code{"bootstrap"} — Bootstrap CSS; \code{"highlight"} — highlight.js CSS).}

\item{language}{Langauge of content. If \code{FALSE} then will not include
language field. If \code{TRUE} then will attempt to auto-detect language.
Otherwise will use the specified language.}

\item{interpolate}{Whether or not to interpolate into input using \link[glue]{glue}.}

\item{.open}{The opening delimiter.}

\item{.close}{The closing delimiter.}

\item{.envir}{Environment used for \code{glue} interpolation. Defaults to \code{parent.frame()}.}
}
\value{
A message object.
}
\description{
Render either Plain Markdown or R Markdown directly into the body of an email.

If \code{input} is a file then it will be interpreted as R Markdown it its
extension is either \code{"Rmd"} or \code{"Rmarkdown"}. Otherwise it will be
processed as Plain Markdown.
}
\section{Plain Markdown}{


Plain Markdown is processed with \code{\link[commonmark:commonmark]{commonmark::markdown_html()}}.
}

\section{R Markdown}{


R Markdown is processed with \code{\link[rmarkdown:render]{rmarkdown::render()}}.

Regardless of what \code{output} type is specified in the input file,
\code{render()} will always use the \code{"html_document"} output format.
}

\examples{

# Plain Markdown

markdown <- "[This](https://www.google.com) is a link."
filename <- "message.md"

# Render from Markdown in character vector.
msg <- envelope() \%>\% render(markdown)

# Create a file containing Markdown
cat(markdown, file = filename)

# Render from Markdown in file.
msg <- envelope() \%>\% render(filename)

# Cleanup.
file.remove(filename)

# R Markdown

filename <- "gh-doc.Rmd"

# Create an Rmd document from template.
rmarkdown::draft(
  filename,
  template = "github_document",
  package = "rmarkdown",
  edit = FALSE
)

# Check for suitable version of Pandoc (https://pandoc.org/).
#
# Need to have version 2.0 or greater to support required --quiet option.
#
pandoc <- rmarkdown::find_pandoc()
suitable_pandoc <- !is.null(pandoc$dir) && grepl("^2", pandoc$version)

# Render from Rmd file.
if (suitable_pandoc) {
  msg <- envelope() \%>\%
    render(filename, include_css = c("rmd", "highlight"))
}

# Cleanup.
file.remove(filename)
}
\seealso{
\code{\link{text}}, \code{\link{html}}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/address.R
\name{address}
\alias{address}
\title{Email Address}
\usage{
address(email = NA, display = NA, local = NA, domain = NA, normalise = TRUE)
}
\arguments{
\item{email}{Email address.}

\item{display}{Display name.}

\item{local}{Local part of email address.}

\item{domain}{Domain part of email address.}

\item{normalise}{Whether to try to normalise address to RFC-5321 requirements.}
}
\value{
An \code{address} object, representing an email address.
}
\description{
Create an \code{address} object which represents an email address.
}
\details{
Implemented as an \href{https://cran.r-project.org/package=vctrs/vignettes/s3-vector.html}{S3 vector class}.
}
\examples{
address("gerry@gmail.com")
address("gerry@gmail.com", "Gerald")
address(
  c("gerry@gmail.com", "alice@yahoo.com", "jim@aol.com"),
  c("Gerald", "Alice", NA)
)
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/header-receipt.R
\name{request_receipt_read}
\alias{request_receipt_read}
\title{Request read receipt}
\usage{
request_receipt_read(msg, addr = NULL)
}
\arguments{
\item{msg}{A message object.}

\item{addr}{Single address.}
}
\value{
A message object.
}
\description{
Request the recipient to acknowledge that they have read the message. Inserts
MDN (Message Disposition Notification) header entries.
}
